#include "ns.h"
#include "wh.h"

BEGIN_WH_NS

void spawnabaddy(DWHActor* actor, int monster);

static void chasejudy(PLAYER& plr, DWHActor* actor)
{
	SPRITE& spr = actor->s();

	spr.lotag -= TICSPERFRAME;
	if (spr.lotag < 0)
		spr.lotag = 250;

	auto osectnum = spr.sectnum;

	if (mapon < 24) {
		spr.extra -= TICSPERFRAME;
		if (spr.extra < 0) {
			for (int j = 0; j < 8; j++)
				trailingsmoke(actor,true);
			DeleteActor(actor);
			return;
		}
	}

	if (krand() % 63 == 0) {
		if (cansee(plr.x, plr.y, plr.z, plr.sector, spr.x, spr.y,
			spr.z - (tileHeight(spr.picnum) << 7), spr.sectnum))// && invisibletime < 0)
			SetNewStatus(actor, ATTACK);
	}
	else {
		checksight(plr, actor);
		if (!checkdist(actor, plr.x, plr.y, plr.z)) {
			auto moveStat = aimove(actor);
			if (moveStat.type == kHitFloor)
			{
				spr.ang = ((spr.ang + 1024) & 2047);
				SetNewStatus(actor, FLEE);
				return;
			}
		}
		else {
			if (krand() % 8 == 0) // NEW
				SetNewStatus(actor, ATTACK); // NEW
			else { // NEW
				spr.ang = (((krand() & 512 - 256) + spr.ang + 1024) & 2047); // NEW
				SetNewStatus(actor, FLEE); // NEW
			}
		}
	}

	getzrange(spr.x, spr.y, spr.z - 1, spr.sectnum, (spr.clipdist) << 2, CLIPMASK0);
	spr.z = zr_florz;

	if ((spr.sectnum != osectnum) && (spr.sector()->lotag == 10))
		warpsprite(actor);

	if (checksector6(actor))
		return;

	processfluid(actor, zr_florHit, false);

	if (sector[osectnum].lotag == KILLSECTOR) {
		spr.hitag--;
		if (spr.hitag < 0)
			SetNewStatus(actor, DIE);
	}

	SetActorPos(actor, &spr.pos);
}
	
static void resurectjudy(PLAYER& plr, DWHActor* actor)
{
	SPRITE& spr = actor->s();

	spr.lotag -= TICSPERFRAME;
	if (spr.lotag < 0) {
		SetNewStatus(actor, FACE);
		spr.picnum = JUDY;
		spr.hitag = adjusthp(200);
		spr.lotag = 100;
		spr.cstat |= 1;
	}
}
	
static void searchjudy(PLAYER& plr, DWHActor* actor)
{
	aisearch(plr, actor, false);
	checksector6(actor);
}
	
static void nukedjudy(PLAYER& plr, DWHActor* actor)
{
	SPRITE& spr = actor->s();

	spr.lotag -= TICSPERFRAME;
	if (spr.lotag < 0) {
		spr.picnum++;
		spr.lotag = 24;
		if (spr.picnum == JUDYCHAR + 4) {
			trailingsmoke(actor,false);
			DeleteActor(actor);
		}
	}
}
	
static void painjudy(PLAYER& plr, DWHActor* actor)
{
	SPRITE& spr = actor->s();

	spr.lotag -= TICSPERFRAME;
	if (spr.lotag < 0) {
		spr.picnum = JUDY;
		spr.ang = plr.angle.ang.asbuild();
		SetNewStatus(actor, FLEE);
	}

	aimove(actor);
	processfluid(actor, zr_florHit, false);
	SetActorPos(actor, &spr.pos);
}
	
static void facejudy(PLAYER& plr, DWHActor* actor)
{
	SPRITE& spr = actor->s();

	spr.ang = getangle(plr.x - spr.x, plr.y - spr.y);

	boolean cansee = ::cansee(plr.x, plr.y, plr.z, plr.sector, spr.x, spr.y, spr.z - (tileHeight(spr.picnum) << 7),
		spr.sectnum);

	if (cansee && plr.invisibletime < 0) {
		if (plr.shadowtime > 0) {
			spr.ang = (((krand() & 512 - 256) + spr.ang + 1024) & 2047);
			SetNewStatus(actor, FLEE);
		}
		else {
			actor->SetOwner(plr.actor());
			SetNewStatus(actor, CHASE);
		}
	}
	else { // get off the wall
		if (actor->GetOwner() == plr.actor()) {
			spr.ang = (((krand() & 512 - 256) + spr.ang) & 2047);
			SetNewStatus(actor, FINDME);
		}
		else if (cansee) SetNewStatus(actor, FLEE);
	}

	if (checkdist(actor, plr.x, plr.y, plr.z))
		SetNewStatus(actor, ATTACK);
}
	
static void attackjudy(PLAYER& plr, DWHActor* actor)
{
	SPRITE& spr = actor->s();

	getzrange(spr.x, spr.y, spr.z - 1, spr.sectnum, (spr.clipdist) << 2, CLIPMASK0);
	spr.z = zr_florz;

	switch (checkfluid(actor, zr_florHit)) {
	case TYPELAVA:
	case TYPEWATER:
		spr.z += tileHeight(spr.picnum) << 5;
		break;
	}

	SetActorPos(actor, &spr.pos);

	spr.extra -= TICSPERFRAME;
	spr.lotag -= TICSPERFRAME;
	if (spr.lotag < 0) {
		if (cansee(plr.x, plr.y, plr.z, plr.sector, spr.x, spr.y,
			spr.z - (tileHeight(spr.picnum) << 7), spr.sectnum))
			SetNewStatus(actor, CAST);
		else
			SetNewStatus(actor, CHASE);
	}
	else
		spr.ang = getangle(plr.x - spr.x, plr.y - spr.y);
}
	
static void fleejudy(PLAYER& plr, DWHActor* actor)
{
	SPRITE& spr = actor->s();

	spr.lotag -= TICSPERFRAME;
	auto osectnum = spr.sectnum;

	auto moveStat = aimove(actor);
	if (moveStat.type != kHitFloor && moveStat.type != kHitNone) {
		if (moveStat.type == kHitWall) {
			int nWall = moveStat.index;
			int nx = -(wall[wall[nWall].point2].y - wall[nWall].y) >> 4;
			int ny = (wall[wall[nWall].point2].x - wall[nWall].x) >> 4;
			spr.ang = getangle(nx, ny);
		}
		else {
			spr.ang = getangle(plr.x - spr.x, plr.y - spr.y);
			SetNewStatus(actor, FACE);
		}
	}
	if (spr.lotag < 0)
		SetNewStatus(actor, FACE);

	if ((spr.sectnum != osectnum) && (spr.sector()->lotag == 10))
		warpsprite(actor);

	if (checksector6(actor))
		return;

	processfluid(actor, zr_florHit, false);

	SetActorPos(actor, &spr.pos);
}
	
static void castjudy(PLAYER& plr, DWHActor* actor)
{
	SPRITE& spr = actor->s();

	spr.lotag -= TICSPERFRAME;
	if (spr.lotag < 0) {
		spr.picnum++;
		spr.lotag = 12;
	}

	if (spr.picnum == JUDYATTACK1 + 3) {
		spr.picnum = JUDYATTACK1;
		spritesound(S_JUDY1 + krand() % 4, actor);
		if (krand() % 100 > 70) {
			castspell(plr, actor);
		}
		else {
			if (krand() % 100 > 40) {
				// raise the dead
				WHStatIterator it(DEAD);
				while (auto itActor = it.Next())
				{
					SPRITE& spr = itActor->s();
					spr.lotag = ((krand() % 120) + 120);
					kills--;
					SetNewStatus(itActor, RESURECT);
				}
			}
			else {
				if (krand() % 100 > 50) {
					// curse
					for (int j = 1; j < 9; j++) {
						plr.ammo[j] = 3;
					}
				}
				else {
					int j = krand() % 5;
					switch (j) {
					case 0:// SPAWN WILLOW
						spawnabaddy(actor, WILLOW);
						break;
					case 1:// SPAWN 10 SPIDERS
						for (j = 0; j < 4; j++) {
							spawnabaddy(actor, SPIDER);
						}
						break;
					case 2:// SPAWN 2 GRONSW
						for (j = 0; j < 2; j++) {
							spawnabaddy(actor, GRONSW);
						}
						break;
					case 3:// SPAWN SKELETONS
						for (j = 0; j < 4; j++) {
							spawnabaddy(actor, SKELETON);
						}
						break;
					case 4:
						castspell(plr, actor);
						break;
					}
				}
			}
		}
		SetNewStatus(actor, CHASE);
	}
	else if (spr.picnum == JUDYATTACK2 + 8) {
		spr.picnum = JUDYATTACK2;
		spritesound(S_JUDY1 + krand() % 4, actor);
		if (krand() % 100 > 50)
			skullycastspell(plr, actor);
		else {
			if (krand() % 100 > 70) {
				if (krand() % 100 > 50) {
					plr.health = 0;
					addhealth(plr, 1);
				}
				else {
					addarmor(plr, -(plr.armor));
					plr.armortype = 0;
				}
			}
			else {
				int j = krand() % 5;
				switch (j) {
				case 0:// SPAWN WILLOW
					spawnabaddy(actor, WILLOW);
					break;
				case 1:// SPAWN 6 SPIDERS
					for (j = 0; j < 4; j++) {
						spawnabaddy(actor, SPIDER);
					}
					break;
				case 2:// SPAWN 2 GRONSW
					for (j = 0; j < 2; j++) {
						spawnabaddy(actor, GRONSW);
					}
					break;
				case 3:// SPAWN SKELETONS
					for (j = 0; j < 4; j++) {
						spawnabaddy(actor, SKELETON);
					}
					break;
				case 4:
					castspell(plr, actor);
					break;
				}
			}

		}
		SetNewStatus(actor, CHASE);
	}
	checksector6(actor);
}
	
static void diejudy(PLAYER& plr, DWHActor* actor)
{
	SPRITE& spr = actor->s();

	spr.lotag -= TICSPERFRAME;

	if (spr.lotag <= 0) {
		spr.picnum++;
		spr.lotag = 20;

		if (spr.picnum == JUDYDEAD) {
			if (difficulty == 4)
				SetNewStatus(actor, RESURECT);
			else {
				kills++;
				SetNewStatus(actor, DEAD);
			}
		}
	}
}
	
void judyOperate(PLAYER& plr)
{
	WHStatIterator it(WITCHSIT);
	while (auto actor = it.Next())
	{
		SPRITE& spri = actor->s();

		spri.ang = (getangle(plr.x - spri.x, plr.y - spri.y) & 2047);
		if (cansee(plr.x, plr.y, plr.z, plr.sector, spri.x, spri.y,
			spri.z - (tileHeight(spri.picnum) << 7), spri.sectnum)) {
			spri.lotag -= TICSPERFRAME;
			if (spri.lotag < 0) {
				spri.picnum++;
				spri.lotag = 12;
				if (spri.picnum == JUDYSIT + 4) {
					spri.picnum = JUDY;
					SetNewStatus(actor, FACE);
				}
			}
		}
	}
}
	
void spawnabaddy(DWHActor* actor, int monster) {
	auto& spr = actor->s();
	auto spawnedactor = InsertActor(spr.sectnum, FACE);
	auto& spawned = spawnedactor->s();

	spawned.x = spr.x + (krand() & 2048) - 1024;
	spawned.y = spr.y + (krand() & 2048) - 1024;
	spawned.z = spr.z;

	spawned.pal = 0;
	spawned.shade = 0;
	spawned.cstat = 0;

	if (monster == WILLOW)
		premapWillow(spawnedactor);
	else if (monster == SPIDER)
		premapSpider(spawnedactor);
	else if (monster == GRONSW)
		premapGron(spawnedactor);
	else if (monster == SKELETON)
		premapSkeleton(spawnedactor);
	else if (monster == GONZOGSH)
		premapGonzo(spawnedactor);

	spawned.picnum = monster;
	killcnt++;

	SetActorPos(spawnedactor, &spawned.pos);
	spawned.backuploc();
}


void createJudyAI() {
	auto& e = enemy[JUDYTYPE];
	e.info.Init(32, 32, 2048, 120, 0, 64, false, 500, 0);
	e.chase = chasejudy;
	e.resurect = resurectjudy;
	e.search = searchjudy;
	e.nuked = nukedjudy;
	e.pain = painjudy;
	e.face = facejudy;
	e.attack = attackjudy;
	e.flee = fleejudy;
	e.cast = castjudy;
	e.die = diejudy;
}

void premapJudy(DWHActor* actor) {
	SPRITE& spr = actor->s();
	spr.detail = JUDYTYPE;

	enemy[JUDYTYPE].info.set(spr);

	if (mapon > 24)
		spr.hitag = adjusthp(700);

	if (spr.picnum == JUDYSIT) {
		ChangeActorStat(actor, WITCHSIT);
		spr.extra = 1200;
	}
	else
		ChangeActorStat(actor, FACE);
}

END_WH_NS
