#include "ns.h"
#include "wh.h"

BEGIN_WH_NS

static int weaponuseless = 0;
static boolean madeahit;
static int weapondropgoal;
int arrowcnt, throwpikecnt;


// EG 17 Oct 2017: Backport shield toggle
int dropshieldcnt = 0;
boolean droptheshield = false;
int dahand = 0;
int oweapondrop, weapondrop;
double osnakex, osnakey, snakex, snakey;

boolean checkmedusadist(DWHActor* actor, int x, int y, int z, int lvl) {
	auto& spr = actor->s();
	int attackdist = (isWh2() ? 8192 : 1024) + (lvl << 9);

	if ((abs(x - spr.x) + abs(y - spr.y) < attackdist)
			&& (abs((z >> 8) - ((spr.z >> 8) - (tileHeight(spr.picnum) >> 1))) <= 120))
		return true;
	else
		return false;
}

static void playEnchantedSound(int sndnum)
{
	if (soundEngine->GetSoundPlayingInfo(SOURCE_Any, nullptr, 0, CHAN_ENCHANTED) == 0)
		playsound(sndnum, 0, 0, -1, CHAN_ENCHANTED);
}

void autoweaponchange(PLAYER& plr, int dagun) {
	if (plr.currweaponanim > 0 || dagun == plr.selectedgun || plr.currweaponflip > 0)
		return;

	plr.selectedgun = dagun;
	plr.hasshot = 0;
	plr.currweaponfired = 2; // drop weapon

	soundEngine->StopSound(CHAN_ENCHANTED);
	switch (plr.selectedgun) {
	case 0:
		weapondropgoal = 40;
		weapondrop = 0;
	case 1:
		weapondropgoal = 100;
		weapondrop = 0;
		break;
	case 2:
		if (plr.weapon[plr.selectedgun] == 3) {
			playEnchantedSound(S_FIREWEAPONLOOP);
		}
		weapondropgoal = (isWh2() ? 40 : 100);
		weapondrop = 0;
		break;
	case 3:
		if (plr.weapon[plr.selectedgun] == 3) {
			playEnchantedSound(S_ENERGYWEAPONLOOP);
		}
		weapondropgoal = 100;
		weapondrop = 0;
		break;
	case 4:
		weapondropgoal = 40;
		weapondrop = 0;
		break;
	case 5:
		if (plr.weapon[plr.selectedgun] == 3) {
			playEnchantedSound(S_ENERGYWEAPONLOOP);
		}
		weapondropgoal = 40;
		weapondrop = 0;
		break;
	case 6:
		if (plr.weapon[plr.selectedgun] == 3) {
			playEnchantedSound(S_FIREWEAPONLOOP);
		}
		weapondropgoal = 40;
		weapondrop = 0;
		if (plr.ammo[6] < 0)
			plr.ammo[6] = 0;
		break;
	case 7:
		if (plr.weapon[plr.selectedgun] == 3) {
			playEnchantedSound(S_ENERGYWEAPONLOOP);
		}
		weapondropgoal = 40;
		weapondrop = 0;
		if (plr.weapon[7] == 2) {
			if (plr.ammo[7] < 0)
				plr.ammo[7] = 0;
		}
		break;
	case 8:
//			if (plr.weapon[plr.selectedgun] == 3) {
//						playEnchantedSound(S_FIREWEAPONLOOP);
//			}
		weapondropgoal = 40;
		weapondrop = 0;
		break;
	case 9:
		weapondropgoal = 40;
		weapondrop = 0;
		break;
	}
}

void weaponchange(int snum) {
	PLAYER& plr = player[snum];
	if (plr.currweaponanim == 0 && plr.currweaponflip == 0) {
		int key = (plr.plInput.actions & SB_WEAPONMASK_BITS) / SB_FIRST_WEAPON_BIT - 1;
		if (key != -1 && key < 12) {
			if (key == 10 || key == 11) {
				int k = plr.currweapon;
				key = (key == 10 ? -1 : 1);
				while (k >= 0 && k < 10) {
					k += key;

					if (k == -1)
						k = 9;
					else if (k == 10)
						k = 0;

					if (plr.weapon[k] > 0) {
						key = k;
						break;
					}
				}
			}
			int gun = key;
			if (plr.weapon[gun] > 0) {
				if (plr.currweaponanim <= 0 && gun != plr.selectedgun && plr.currweaponflip <= 0) {
					soundEngine->StopSound(CHAN_ENCHANTED);
				}

				autoweaponchange(plr, gun);
			}
		}
	}
}

void plrfireweapon(PLAYER& plr) {
	if (plr.currweaponfired == 4) {
		if (isWh2()) {
			plr.currweapontics = wh2throwanimtics[plr.currentorb][0].daweapontics;
		} else
			plr.currweapontics = throwanimtics[plr.currentorb][0].daweapontics;
		return;
	}

	if (plr.ammo[plr.selectedgun] <= 0) {
		if (plr.currweapon == 6) {
			for (int i = 0; i < MAXWEAPONS; i++) {
				if (plr.ammo[i] > 0 && plr.weapon[i] == 1) {
					plr.selectedgun = i;
					plr.hasshot = 0;
					plr.currweaponfired = 2; // drop weapon
					weapondropgoal = 100;
					weapondrop = 0;
				}
			}
		}
		return;
	} else {
		madeahit = false;
		plr.ammo[plr.selectedgun]--;

		if (isWh2() && plr.weapon[plr.selectedgun] == 3) {
			if (plr.ammo[plr.selectedgun] == 0) {
				plr.weapon[plr.selectedgun] = plr.preenchantedweapon[plr.selectedgun];
				plr.ammo[plr.selectedgun] = plr.preenchantedammo[plr.selectedgun];
				soundEngine->StopSound(CHAN_ENCHANTED);
			}
		}

		if (plr.ammo[plr.selectedgun] <= 0 || plr.ammo[plr.selectedgun] == 10) {
			switch (plr.selectedgun) {
			case 0: // fist
				plr.ammo[0] = 9999;
				break;
			case 1: // knife
				if (plr.ammo[plr.selectedgun] == 10) {
					showmessage("Dagger is damaged", 360);
				}
				if (plr.ammo[plr.selectedgun] <= 0) {
					plr.ammo[1] = 0;
					plr.weapon[1] = 0;
					showmessage("Dagger is Useless", 360);
					weaponuseless = 1;
				}
				break;
			case 2: // Short sword
				if (plr.ammo[plr.selectedgun] == 10) {
					showmessage("Short Sword is damaged", 360);
				}
				if (plr.ammo[plr.selectedgun] <= 0) {
					plr.ammo[2] = 0;
					plr.weapon[2] = 0;
					showmessage("Short Sword is Useless", 360);
					weaponuseless = 1;
				}
				break;
			case 3: // mace
				if (plr.ammo[plr.selectedgun] == 10) {
					showmessage("Morning Star is damaged", 360);
				}
				if (plr.ammo[plr.selectedgun] <= 0) {
					plr.ammo[3] = 0;
					plr.weapon[3] = 0;
					showmessage("Morning Star is Useless", 360);
					weaponuseless = 1;
				}
				break;

			case 4: // sword
				if (plr.ammo[plr.selectedgun] == 10) {
					showmessage("Sword is damaged", 360);
				}
				if (plr.ammo[plr.selectedgun] <= 0) {
					plr.ammo[4] = 0;
					plr.weapon[4] = 0;
					showmessage("Sword is Useless", 360);
					weaponuseless = 1;
				}
				break;
			case 5: // battle axe
				if (plr.ammo[plr.selectedgun] == 10) {
					showmessage("Battle axe is damaged", 360);
				}
				if (plr.ammo[plr.selectedgun] <= 0) {
					plr.ammo[5] = 0;
					plr.weapon[5] = 0;
					showmessage("Battle axe is Useless", 360);
					weaponuseless = 1;
				}
				break;
			case 6: // bow
				break;
			case 7: // pike
				if (plr.weapon[7] == 1) {
					if (plr.ammo[plr.selectedgun] == 10) {
						showmessage("Pike is damaged", 360);
					}
					if (plr.ammo[plr.selectedgun] <= 0) {
						plr.ammo[7] = 0;
						plr.weapon[7] = 0;
						showmessage("Pike is Useless", 360);
						weaponuseless = 1;
					}
				}
				if (plr.weapon[7] == 2 && plr.ammo[7] <= 0) {
					plr.weapon[7] = 1;
					plr.ammo[7] = 30;
				}
				break;
			case 8: // two handed sword
				if (plr.ammo[plr.selectedgun] == 10) {
					showmessage("Magic Sword is damaged", 360);
				}
				if (plr.ammo[plr.selectedgun] <= 0) {
					plr.ammo[8] = 0;
					plr.weapon[8] = 0;
					showmessage("Magic Sword is Useless", 360);
					weaponuseless = 1;
				}
				break;
			case 9: // halberd
				if (plr.ammo[plr.selectedgun] == 10) {
					showmessage("Halberd is damaged", 360);
				}
				if (plr.ammo[plr.selectedgun] <= 0) {
					plr.ammo[9] = 0;
					plr.weapon[9] = 0;
					showmessage("Halberd is Useless", 360);
					weaponuseless = 1;
				}
				break;
			}
		}
	}

	if (weaponuseless == 1)
		for (int i = 0; i < MAXWEAPONS; i++) {
			if (plr.weapon[i] > 0 && plr.ammo[i] > 0) {
				plr.currweapon = plr.selectedgun = i;
				plr.currweaponfired = 3; // ready weapon
				plr.currweaponflip = 0;
				weaponuseless = 0;
			}
		}
	else
		plr.currweaponfired = 1;

	plr.currweapon = plr.selectedgun;

	plr.currweaponattackstyle = krand() % 2;

	if (plr.weapon[7] == 2 && plr.currweapon == 7) {
		plr.currweaponattackstyle = 0;
	} else if (isWh2() && plr.weapon[7] == 3 && plr.currweapon == 7) {
		plr.currweaponattackstyle = 0;
	}

	if (plr.currweapon == 9) {
		if (krand() % 100 > 80)
			plr.currweaponattackstyle = 0;
		else
			plr.currweaponattackstyle = 1;
	}

	if (plr.currweaponanim > 11) {
		if (isWh2()) {
			if (plr.weapon[plr.currweapon] == 1)
				plr.currweapontics = weaponanimtics[plr.currweapon][0].daweapontics;
			else
				plr.currweapontics = zweaponanimtics[plr.currweapon][0].daweapontics;
		} else
			plr.currweapontics = weaponanimtics[plr.currweapon][0].daweapontics;
	}
}

void weaponsprocess(int snum) {
	PLAYER& plr = player[snum];

	if (plr.shadowtime <= 0) {
		if (plr.weapon[plr.currweapon] == 3) {
			if (plr.weapon[plr.selectedgun] == 3) {
				switch (plr.selectedgun) {
				case 2:
				case 6:
					playEnchantedSound(S_FIREWEAPONLOOP);
					break;
				default:
					playEnchantedSound(S_ENERGYWEAPONLOOP);
					break;
				}
			}
		}
	}

	if (plr.currweapon == 0 && dahand == 0)
		if (krand() % 2 == 0)
			dahand = 1;
		else
			dahand = 2;

	switch (plr.currweaponfired) {
	case 6:
		switch (plr.currweapon) {
		case 1: // knife
			if (plr.currweaponframe == KNIFEATTACK2 + 1)
				if ((plr.currweaponanim == 2 || plr.currweaponanim == 10) && plr.currweapontics == 8)
					swingdasound(plr.currweapon, plr.weapon[plr.currweapon] == 3);
			break;
		case 3: // morning
			if (plr.currweaponframe == MORNINGATTACK2 + 3)
				if (plr.currweaponanim == 3 && plr.currweapontics == 12)
					swingdasound(plr.currweapon, plr.weapon[plr.currweapon] == 3);
			break;
		}

		if (plr.currweaponframe == RFIST + 5 || plr.currweaponframe == KNIFEATTACK + 6
				|| plr.currweaponframe == ZKNIFEATTACK + 5 // new
				|| plr.currweaponframe == MORNINGSTAR + 5 || plr.currweaponframe == SWORDATTACK + 7
				|| plr.currweaponframe == BOWWALK + 5 || plr.currweaponframe == ZBOWATTACK + 4
				|| plr.currweaponframe == KNIFEATTACK2 + 2 || plr.currweaponframe == ZKNIFEATTACK2 + 2
				|| plr.currweaponframe == SWORDATTACK2 + 6 || plr.currweaponframe == MORNINGATTACK2 + 3
				|| plr.currweaponframe == HALBERDATTACK1 + 3 || plr.currweaponframe == HALBERDATTACK2 + 3
				|| plr.currweaponframe == BIGAXEATTACK + 7 || plr.currweaponframe == BIGAXEATTACK2 + 6
				|| plr.currweaponframe == PIKEATTACK1 + 4 || plr.currweaponframe == PIKEATTACK2 + 4
				|| plr.currweaponframe == EXCALATTACK1 + 7 || plr.currweaponframe == EXCALATTACK2 + 5
				|| plr.currweaponframe == GOBSWORDATTACK2 + 4 || plr.currweaponframe == GOBSWORDATTACK + 4
				|| plr.currweaponframe == ZSHORTATTACK + 7 || plr.currweaponframe == ZSHORTATTACK2 + 4
				|| plr.currweaponframe == ZSTARATTACK + 7 || plr.currweaponframe == ZSTARATTACK2 + 3
				|| plr.currweaponframe == ZAXEATTACK + 12 || plr.currweaponframe == ZAXEATTACK2 + 6
				|| plr.currweaponframe == ZPIKEATTACK + 4 || plr.currweaponframe == ZPIKEATTACK2 + 4
				|| plr.currweaponframe == ZTWOHANDATTACK + 12 || plr.currweaponframe == ZTWOHANDATTACK2 + 5
				|| plr.currweaponframe == ZHALBERDATTACK + 4 || plr.currweaponframe == ZHALBERDATTACK2 + 3)

			swingdaweapon(plr);

		plr.currweapontics -= TICSPERFRAME;
		if (plr.helmettime > 0)
			plr.currweapontics--;

		if (plr.currweapontics < 0) {
			plr.currweaponanim++;

			if (plr.currweaponanim > 11) {
				plr.currweaponanim = 0;
				plr.currweaponfired = 0;
				plr.currweaponflip = 0;
				plr.currweapon = plr.selectedgun;
				if (dahand > 0)
					dahand = 0;
			}

			if (isWh2()) {
				if (plr.weapon[plr.currweapon] == 1 || plr.weapon[7] == 2) {
					plr.currweapontics = lefthandanimtics[plr.currweapon][plr.currweaponanim].daweapontics;
					plr.currweaponframe = lefthandanimtics[plr.currweapon][plr.currweaponanim].daweaponframe;
				} else {
					plr.currweapontics = zlefthandanimtics[plr.currweapon][plr.currweaponanim].daweapontics;
					plr.currweaponframe = zlefthandanimtics[plr.currweapon][plr.currweaponanim].daweaponframe;

				}
			} else {
				plr.currweapontics = lefthandanimtics[plr.currweapon][plr.currweaponanim].daweapontics;
				plr.currweaponframe = lefthandanimtics[plr.currweapon][plr.currweaponanim].daweaponframe;
			}
		} else {
			if (isWh2()) {
				if (plr.weapon[plr.currweapon] == 1 || plr.weapon[7] == 2) {
					plr.currweaponframe = lefthandanimtics[plr.currweapon][plr.currweaponanim].daweaponframe;
				} else {
					plr.currweaponframe = zlefthandanimtics[plr.currweapon][plr.currweaponanim].daweaponframe;
				}
			} else
				plr.currweaponframe = lefthandanimtics[plr.currweapon][plr.currweaponanim].daweaponframe;
		}

		if (plr.currweapon == 0 && plr.currweaponframe == 0) {
			dahand = 0;
			plr.currweaponanim = 0;
			plr.currweaponfired = 0;
		}

		if (plr.selectedgun == 4 && plr.currweaponframe == 0) {
			plr.currweaponanim = 0;
			plr.currweaponfired = 0;
			plr.currweaponflip = 0;
			plr.currweapon = plr.selectedgun;
		}
		break;
	case 1: // fire
		switch (plr.currweapon) {
		case 0: // fist
			if (plr.currweaponframe == RFIST + 5)
				if (plr.currweaponanim == 5 && plr.currweapontics == 10)
					swingdasound(plr.currweapon, plr.weapon[plr.currweapon] == 3);
			break;
		case 1: // knife
			if (plr.currweaponframe == KNIFEATTACK + 6 || plr.currweaponframe == ZKNIFEATTACK + 5)
				if (plr.currweaponanim == 8 && plr.currweapontics == 8)
					swingdasound(plr.currweapon, plr.weapon[plr.currweapon] == 3);
			if (plr.currweaponframe == KNIFEATTACK2 + 2 || plr.currweaponframe == ZKNIFEATTACK2 + 2)
				if ((plr.currweaponanim == 5 || plr.currweaponanim == 9) && plr.currweapontics == 8)
					swingdasound(plr.currweapon, plr.weapon[plr.currweapon] == 3);
			break;
		case 2: // Shortsword
			if (plr.currweaponframe == GOBSWORDATTACK + 4 || plr.currweaponframe == ZSHORTATTACK + 7)
				if (plr.currweaponanim == 4 && plr.currweapontics == 10)
					swingdasound(plr.currweapon, plr.weapon[plr.currweapon] == 3);
			if (plr.currweaponframe == GOBSWORDATTACK2 + 4 || plr.currweaponframe == ZSHORTATTACK2 + 4)
				if (plr.currweaponanim == 4 && plr.currweapontics == 10)
					swingdasound(plr.currweapon, plr.weapon[plr.currweapon] == 3);
			break;
		case 3: // morning
			if (plr.currweaponframe == MORNINGSTAR + 5 || plr.currweaponframe == ZSTARATTACK + 7)
				if (plr.currweaponanim == 7 && plr.currweapontics == 12)
					swingdasound(plr.currweapon, plr.weapon[plr.currweapon] == 3);
			if (plr.currweaponframe == MORNINGATTACK2 + 3 || plr.currweaponframe == ZSTARATTACK2 + 3)
				if (plr.currweaponanim == 3 && plr.currweapontics == 12)
					swingdasound(plr.currweapon, plr.weapon[plr.currweapon] == 3);
			break;
		case 4: // sword
			if (plr.currweaponframe == SWORDATTACK + 7)
				if (plr.currweaponanim == 7 && plr.currweapontics == 8)
					swingdasound(plr.currweapon, plr.weapon[plr.currweapon] == 3);
			if (plr.currweaponframe == SWORDATTACK2 + 6)
				if (plr.currweaponanim == 6 && plr.currweapontics == 8)
					swingdasound(plr.currweapon, plr.weapon[plr.currweapon] == 3);
			break;
		case 5: // battleaxe
			if (plr.currweaponframe == BIGAXEATTACK + 7 || plr.currweaponframe == ZAXEATTACK + 12)
				if (plr.currweaponanim == 7 && plr.currweapontics == 12)
					swingdasound(plr.currweapon, plr.weapon[plr.currweapon] == 3);
			if (plr.currweaponframe == BIGAXEATTACK2 + 6 || plr.currweaponframe == ZAXEATTACK2 + 6)
				if (plr.currweaponanim == 6 && plr.currweapontics == 12)
					swingdasound(plr.currweapon, plr.weapon[plr.currweapon] == 3);
			break;
		case 6: // bow
			if (plr.currweaponframe == BOWWALK + 4)
				if (plr.currweaponanim == 4 && plr.currweapontics == 6)
					swingdasound(plr.currweapon, plr.weapon[plr.currweapon] == 3);
			if (plr.currweaponframe == ZBOWATTACK + 4)
				if (plr.currweaponanim == 4 && plr.currweapontics == 6)
					swingdasound(plr.currweapon, plr.weapon[plr.currweapon] == 3);
			break;
		case 7: // pike
			if (plr.currweaponframe == PIKEATTACK1 + 4 || plr.currweaponframe == ZPIKEATTACK + 4)
				if (plr.currweaponanim == 8 && plr.currweapontics == 10)
					swingdasound(plr.currweapon, plr.weapon[plr.currweapon] == 3);
			if (plr.currweaponframe == PIKEATTACK2 + 4 || plr.currweaponframe == ZPIKEATTACK2 + 4)
				if (plr.currweaponanim == 4 && plr.currweapontics == 10)
					swingdasound(plr.currweapon, plr.weapon[plr.currweapon] == 3);
			break;
		case 8: // two handed sword
			if (plr.currweaponframe == EXCALATTACK1 + 7 || plr.currweaponframe == ZTWOHANDATTACK + 12)
				if (plr.currweaponanim == 7 && plr.currweapontics == 8)
					swingdasound(plr.currweapon, plr.weapon[plr.currweapon] == 3);
			if (plr.currweaponframe == EXCALATTACK2 + 5 || plr.currweaponframe == ZTWOHANDATTACK2 + 5)
				if (plr.currweaponanim == 5 && plr.currweapontics == 8)
					swingdasound(plr.currweapon, plr.weapon[plr.currweapon] == 3);
			break;
		case 9: // halberd
			if (plr.currweaponframe == HALBERDATTACK1 + 3 || plr.currweaponframe == ZHALBERDATTACK + 4)
				if (plr.currweaponanim == 7 && plr.currweapontics == 12)
					swingdasound(plr.currweapon, plr.weapon[plr.currweapon] == 3);
			if (plr.currweaponframe == HALBERDATTACK2 + 3 || plr.currweaponframe == ZHALBERDATTACK2 + 3)
				if (plr.currweaponanim == 4 && plr.currweapontics == 12)
					swingdasound(plr.currweapon, plr.weapon[plr.currweapon] == 3);
			break;
		}

		if (plr.currweaponframe == RFIST + 5 || plr.currweaponframe == KNIFEATTACK + 6
				|| plr.currweaponframe == ZKNIFEATTACK + 5 // new
				|| plr.currweaponframe == MORNINGSTAR + 5 || plr.currweaponframe == SWORDATTACK + 7
				|| plr.currweaponframe == BOWWALK + 5 || plr.currweaponframe == ZBOWATTACK + 4
				|| plr.currweaponframe == KNIFEATTACK2 + 2 || plr.currweaponframe == ZKNIFEATTACK2 + 2
				|| plr.currweaponframe == SWORDATTACK2 + 6 || plr.currweaponframe == MORNINGATTACK2 + 3
				|| plr.currweaponframe == HALBERDATTACK1 + 3 || plr.currweaponframe == HALBERDATTACK2 + 3
				|| plr.currweaponframe == BIGAXEATTACK + 7 || plr.currweaponframe == BIGAXEATTACK2 + 6
				|| plr.currweaponframe == PIKEATTACK1 + 4 || plr.currweaponframe == PIKEATTACK2 + 4
				|| plr.currweaponframe == EXCALATTACK1 + 7 || plr.currweaponframe == EXCALATTACK2 + 5
				|| plr.currweaponframe == GOBSWORDATTACK2 + 4 || plr.currweaponframe == GOBSWORDATTACK + 4
				|| plr.currweaponframe == ZSHORTATTACK + 7 || plr.currweaponframe == ZSHORTATTACK2 + 4
				|| plr.currweaponframe == ZSTARATTACK + 7 || plr.currweaponframe == ZSTARATTACK2 + 3
				|| plr.currweaponframe == ZAXEATTACK + 12 || plr.currweaponframe == ZAXEATTACK2 + 6
				|| plr.currweaponframe == ZPIKEATTACK + 4 || plr.currweaponframe == ZPIKEATTACK2 + 4
				|| plr.currweaponframe == ZTWOHANDATTACK + 12 || plr.currweaponframe == ZTWOHANDATTACK2 + 5
				|| plr.currweaponframe == ZHALBERDATTACK + 4 || plr.currweaponframe == ZHALBERDATTACK2 + 3)

			swingdaweapon(plr);

		plr.currweapontics -= TICSPERFRAME;
		if (plr.helmettime > 0)
			plr.currweapontics--;

		if (plr.shieldpoints <= 0)
			droptheshield = true;

		if ((plr.currweaponframe == SWORDATTACK + 7 || plr.currweaponframe == SWORDATTACK2 + 7)
				&& plr.currweapontics < 0 && droptheshield) {
			if (rand() % 100 > 50) {

				if (isWh2()) {
					if (plr.ammo[1] > 0 && plr.weapon[3] == 0) {
						plr.currweapon = 1;
						plr.currweapontics = 6;
						plr.currweaponanim = 0;
						plr.currweaponfired = 6;
						plr.hasshot = 0;
						plr.currweaponflip = 1;
					}
					else if (plr.ammo[3] > 0) {
						plr.currweapon = 3;
						plr.currweapontics = 6;
						plr.currweaponanim = 0;
						plr.currweaponfired = 6;
						plr.hasshot = 0;
						plr.currweaponflip = 1;
					}
				} else {
					if (plr.lvl >= 4 && plr.lvl <= 4 && plr.ammo[1] > 0) {
						plr.currweapon = 1;
						plr.currweapontics = 6;
						plr.currweaponanim = 0;
						plr.currweaponfired = 6;
						plr.hasshot = 0;
						plr.currweaponflip = 1;
					} else if (plr.lvl >= 5 && plr.ammo[3] > 0) {
						plr.currweapon = 3;
						plr.currweapontics = 6;
						plr.currweaponanim = 0;
						plr.currweaponfired = 6;
						plr.hasshot = 0;
						plr.currweaponflip = 1;
					}
				}
			}
		}
		if (plr.currweapontics < 0) {
			plr.currweaponanim++;
			if (plr.currweaponanim > 11) {
				plr.currweaponanim = 0;
				plr.currweaponfired = 0;
				if (dahand > 0)
					dahand = 0;
			}
			if (plr.currweaponattackstyle == 0) {
				if (isWh2()) {
					if (plr.weapon[plr.currweapon] == 1 || plr.weapon[7] == 2) {
						plr.currweapontics = weaponanimtics[plr.currweapon][plr.currweaponanim].daweapontics;
						plr.currweaponframe = weaponanimtics[plr.currweapon][plr.currweaponanim].daweaponframe;
					} else {
						plr.currweapontics = zweaponanimtics[plr.currweapon][plr.currweaponanim].daweapontics;
						plr.currweaponframe = zweaponanimtics[plr.currweapon][plr.currweaponanim].daweaponframe;
					}
				} else {
					plr.currweapontics = weaponanimtics[plr.currweapon][plr.currweaponanim].daweapontics;
					plr.currweaponframe = weaponanimtics[plr.currweapon][plr.currweaponanim].daweaponframe;
				}
			} else {
				if (isWh2()) {
					if (plr.weapon[plr.currweapon] == 1 || plr.weapon[7] == 2) {
						plr.currweapontics = weaponanimtics2[plr.currweapon][plr.currweaponanim].daweapontics;
						plr.currweaponframe = weaponanimtics2[plr.currweapon][plr.currweaponanim].daweaponframe;
					} else {
						plr.currweapontics = zweaponanimtics2[plr.currweapon][plr.currweaponanim].daweapontics;
						plr.currweaponframe = zweaponanimtics2[plr.currweapon][plr.currweaponanim].daweaponframe;
					}
				} else {
					plr.currweapontics = weaponanimtics2[plr.currweapon][plr.currweaponanim].daweapontics;
					plr.currweaponframe = weaponanimtics2[plr.currweapon][plr.currweaponanim].daweaponframe;
				}
			}
		} else {
			if (isWh2()) {
				if (plr.currweaponattackstyle == 0) {
					// flip
					if (plr.weapon[plr.currweapon] == 1 || plr.weapon[7] == 2) {
						plr.currweaponframe = weaponanimtics[plr.currweapon][plr.currweaponanim].daweaponframe;
					} else {
						plr.currweaponframe = zweaponanimtics[plr.currweapon][plr.currweaponanim].daweaponframe;
					}
				} else {
					// flip
					if (plr.weapon[plr.currweapon] == 1 || plr.weapon[7] == 2) {
						plr.currweaponframe = weaponanimtics2[plr.currweapon][plr.currweaponanim].daweaponframe;
					} else {
						plr.currweaponframe = zweaponanimtics2[plr.currweapon][plr.currweaponanim].daweaponframe;
					}
				}
			} else {
				if (plr.currweaponattackstyle == 0) {
					// flip
					plr.currweaponframe = weaponanimtics[plr.currweapon][plr.currweaponanim].daweaponframe;
				} else {
					// flip
					plr.currweaponframe = weaponanimtics2[plr.currweapon][plr.currweaponanim].daweaponframe;
				}
			}
		}

		if (plr.currweapon == 0 && plr.currweaponframe == 0) {
			dahand = 0;
			plr.currweaponanim = 0;
			plr.currweaponfired = 0;
		}
		break;

	case 0: // walking
		if (isWh2()) {
			if (plr.weapon[plr.currweapon] == 1 || plr.weapon[7] == 2)
				plr.currweapontics = weaponanimtics[plr.currweapon][0].daweapontics;
			else
				plr.currweapontics = zweaponanimtics[plr.currweapon][0].daweapontics;

			if (plr.currweapon == 6 && plr.ammo[6] <= 0) {
				// wango
				if (plr.weapon[plr.currweapon] == 1)
					plr.currweaponframe = BOWREADYEND;
				else
					plr.currweaponframe = ZBOWWALK;
			} else {
				if (plr.weapon[plr.currweapon] == 1 || plr.weapon[7] == 2)
					plr.currweaponframe = weaponanimtics[plr.currweapon][0].daweaponframe;
				else
					plr.currweaponframe = zweaponanimtics[plr.currweapon][0].daweaponframe;
			}
		} else {
			plr.currweapontics = weaponanimtics[plr.currweapon][0].daweapontics;

			if (plr.currweapon == 6 && plr.ammo[6] <= 0)
				plr.currweaponframe = BOWREADYEND;
			else
				plr.currweaponframe = weaponanimtics[plr.currweapon][0].daweaponframe;
		}
		if (plr.plInput.fvel || plr.plInput.svel) {
			osnakex = snakex;
			osnakey = snakey;
			snakex = snakey = bsinf(PlayClock << 4, -12);
		}
		break;
	case 2: // unready
		oweapondrop = weapondrop;
		if (plr.currweapon == 1)
			weapondrop += TICSPERFRAME << 1;
		else
			weapondrop += TICSPERFRAME;
		if (weapondrop > weapondropgoal) {
			plr.currweaponfired = 3;
//				weaponraise = 40;
			plr.currweapon = plr.selectedgun;
		}

		if (isWh2()) {
			if (plr.weapon[plr.currweapon] == 1 || plr.weapon[7] == 2)
				plr.currweapontics = weaponanimtics[plr.currweapon][0].daweapontics;
			else
				plr.currweapontics = zweaponanimtics[plr.currweapon][0].daweapontics;

			if (plr.currweapon == 6 && plr.ammo[6] <= 0) {
				if (plr.weapon[plr.currweapon] == 1)
					plr.currweaponframe = BOWREADYEND;
				else
					// currweaponframe=ZBOWREADYEND;
					plr.currweaponframe = ZBOWWALK;
			} else {
				if (plr.weapon[plr.currweapon] == 1 || plr.weapon[7] == 2)
					plr.currweaponframe = weaponanimtics[plr.currweapon][0].daweaponframe;
				else
					plr.currweaponframe = zweaponanimtics[plr.currweapon][0].daweaponframe;
			}
		} else {
			plr.currweapontics = weaponanimtics[plr.currweapon][0].daweapontics;

			if (plr.currweapon == 6 && plr.ammo[6] <= 0)
				plr.currweaponframe = BOWREADYEND;
			else
				plr.currweaponframe = weaponanimtics[plr.currweapon][0].daweaponframe;
		}
		break;
	case 3: // ready
		plr.currweapontics -= TICSPERFRAME;
		if (plr.currweapontics < 0) {
			plr.currweaponanim++;
			if (plr.currweaponanim == 12) {
				plr.currweaponanim = 0;
				plr.currweaponfired = 0;

				if (isWh2()) {
					if (plr.weapon[plr.currweapon] == 1 || plr.weapon[7] == 2) {
						plr.currweaponframe = readyanimtics[plr.currweapon][11].daweaponframe;
					} else {
						plr.currweaponframe = zreadyanimtics[plr.currweapon][11].daweaponframe;
					}
				} else
					plr.currweaponframe = readyanimtics[plr.currweapon][11].daweaponframe;
				break;
			}
			if (isWh2()) {
				if (plr.weapon[plr.currweapon] == 1 || plr.weapon[7] == 2) {
					plr.currweapontics = readyanimtics[plr.currweapon][plr.currweaponanim].daweapontics;
					plr.currweaponframe = readyanimtics[plr.currweapon][plr.currweaponanim].daweaponframe;
				} else {
					plr.currweapontics = zreadyanimtics[plr.currweapon][plr.currweaponanim].daweapontics;
					plr.currweaponframe = zreadyanimtics[plr.currweapon][plr.currweaponanim].daweaponframe;
				}
			} else {
				plr.currweapontics = readyanimtics[plr.currweapon][plr.currweaponanim].daweapontics;
				plr.currweaponframe = readyanimtics[plr.currweapon][plr.currweaponanim].daweaponframe;
			}
		} else {
			if (isWh2()) {
				if (plr.weapon[plr.currweapon] == 1 || plr.weapon[7] == 2) {
					plr.currweaponframe = readyanimtics[plr.currweapon][plr.currweaponanim].daweaponframe;

				} else {
					plr.currweaponframe = zreadyanimtics[plr.currweapon][plr.currweaponanim].daweaponframe;
				}
			} else
				plr.currweaponframe = readyanimtics[plr.currweapon][plr.currweaponanim].daweaponframe;
		}
		break;
	case 5: // cock
		plr.currweapontics -= (TICSPERFRAME);
		if (plr.currweapontics < 0) {
			plr.currweaponanim++;
			if (plr.currweaponanim == 4) {
				plr.currweaponanim = 0;
				plr.currweaponfired = 0;
				if (isWh2()) {
					if (plr.weapon[plr.currweapon] == 1 || plr.weapon[7] == 2) {
						plr.currweaponframe = cockanimtics[3].daweaponframe;
					} else {
						if (plr.weapon[plr.currweapon] == 3) {
							plr.currweaponframe = zcockanimtics[4].daweaponframe;
						} else {
							plr.currweaponframe = cockanimtics[4].daweaponframe;

						}
					}

				} else
					plr.currweaponframe = cockanimtics[3].daweaponframe;
				break;
			}

			if (isWh2()) {
				if (plr.weapon[plr.currweapon] == 1 || plr.weapon[7] == 2) {
					plr.currweapontics = cockanimtics[plr.currweaponanim].daweapontics;
					plr.currweaponframe = cockanimtics[plr.currweaponanim].daweaponframe;
				} else {
					if (plr.weapon[plr.currweapon] == 3) {
						plr.currweapontics = zcockanimtics[plr.currweaponanim].daweapontics;
						plr.currweaponframe = zcockanimtics[plr.currweaponanim].daweaponframe;

					} else {
						plr.currweapontics = cockanimtics[plr.currweaponanim].daweapontics;
						plr.currweaponframe = cockanimtics[plr.currweaponanim].daweaponframe;
					}
				}
			} else {
				plr.currweapontics = cockanimtics[plr.currweaponanim].daweapontics;
				plr.currweaponframe = cockanimtics[plr.currweaponanim].daweaponframe;
			}
		} else {
			if (isWh2()) {
				if (plr.weapon[plr.currweapon] == 1 || plr.weapon[7] == 2) {
					plr.currweaponframe = cockanimtics[plr.currweaponanim].daweaponframe;
				} else {
					if (plr.weapon[plr.currweapon] == 3) {
						plr.currweaponframe = zcockanimtics[plr.currweaponanim].daweaponframe;
					} else {
						plr.currweaponframe = zcockanimtics[plr.currweaponanim].daweaponframe;
					}
				}
			} else
				plr.currweaponframe = cockanimtics[plr.currweaponanim].daweaponframe;
		}
		break;
	case 4: // throw the orb

		if (plr.currweaponframe == 0) 
			castaorb(plr);

		plr.currweapontics -= (TICSPERFRAME);
		if (plr.currweapontics < 0) {
			plr.currweaponanim++;
			if (plr.currweaponanim > 12) {
				plr.currweaponanim = 0;
				plr.currweaponfired = 0;
				plr.orbshot = 0;

				if (isWh2()) {
					plr.currweaponframe = wh2throwanimtics[plr.currentorb][plr.currweaponanim].daweaponframe;
				} else
					plr.currweaponframe = throwanimtics[plr.currentorb][plr.currweaponanim].daweaponframe;
				break;
			}

			if (isWh2()) {
				plr.currweapontics = wh2throwanimtics[plr.currentorb][plr.currweaponanim].daweapontics;
				plr.currweaponframe = wh2throwanimtics[plr.currentorb][plr.currweaponanim].daweaponframe;
			} else {
				plr.currweapontics = throwanimtics[plr.currentorb][plr.currweaponanim].daweapontics;
				plr.currweaponframe = throwanimtics[plr.currentorb][plr.currweaponanim].daweaponframe;
			}

		} else {
			if (isWh2()) {
				plr.currweaponframe = wh2throwanimtics[plr.currentorb][plr.currweaponanim].daweaponframe;
			} else
				plr.currweaponframe = throwanimtics[plr.currentorb][plr.currweaponanim].daweaponframe;
		}
		break;
	}
		
	if(plr.currweaponfired != 4 && plr.orbammo[plr.currentorb] <= 0) 
		spellswitch(plr, 1);

	if (plr.shieldpoints > 0 && (plr.currweaponfired == 0 || plr.currweaponfired == 1) && plr.selectedgun > 0
			&& plr.selectedgun < 5 && !droptheshield) {
		if (plr.currweaponfired == 1) {
			snakex = bsin(PlayClock << 4, -12);
			snakey = bsin(PlayClock << 4, -12);
			if (droptheshield) {
				dropshieldcnt += (TICSPERFRAME << 1);
				snakey += dropshieldcnt;
			}
		}

		if (dropshieldcnt > 200) {
			dropshieldcnt = 0;
			droptheshield = true;
		}
	}
}

void madenoise(PLAYER& plr, int val, int x, int y, int z) {
	WHStatIterator it(FACE);
	while (auto actor = it.Next())
	{
		SPRITE& spr = actor->s();

		if ((abs(x - spr.x) + abs(y - spr.y) < (val * 4096)))
			SetNewStatus(actor, FINDME);
	}
}

void shootgun(PLAYER& plr, float ang, int guntype) {
	int k = 0, daz2;
	DWHActor* hitActor = nullptr;

	int daang = (int) ang;
		
	if(plr.hasshot == 1)
		return;

	Hitscan pHitInfo;
	switch (guntype) {
	case 0:
		daz2 = -MulScale(plr.horizon.horiz.asq16(), 2000, 16);

		hitscan(plr.x, plr.y, plr.z, plr.sector, // Start position
				bcos(daang), // X vector of 3D ang
				bsin(daang), // Y vector of 3D ang
				daz2, // Z vector of 3D ang
				pHitInfo, CLIPMASK1);

		if (pHitInfo.hitsprite >= 0)
		{
			madeahit = true;
			hitActor = &whActors[pHitInfo.hitsprite];
		}

		if (pHitInfo.hitwall >= 0) {
			if ((abs(plr.x - pHitInfo.hitx) + abs(plr.y - pHitInfo.hity) < 512)
					&& (abs((plr.z >> 8) - ((pHitInfo.hitz >> 8) - (64))) <= (512 >> 3))) {
				madeahit = true;
				switch (plr.currweapon) {
				case 0: // fist
					if (plr.currweaponframe == RFIST + 5)
						if (plr.currweaponanim == 5 && plr.currweapontics == 10)
							swingdapunch(plr, plr.currweapon);
					break;
				case 1: // knife
					if (plr.currweaponframe == KNIFEATTACK + 6)
						if (plr.currweaponanim == 8 && plr.currweapontics == 8)
							swingdapunch(plr, plr.currweapon);
					if (plr.currweaponframe == KNIFEATTACK2 + 2)
						if (plr.currweaponanim == 5 || plr.currweaponanim == 9 && plr.currweapontics == 8)
							swingdapunch(plr, plr.currweapon);
					break;
				case 2: // Short sword
					if (plr.currweaponframe == GOBSWORDATTACK + 4 || plr.currweaponframe == ZSHORTATTACK + 7)
						if (plr.currweaponanim == 4 && plr.currweapontics == 10)
							swingdapunch(plr, plr.currweapon);
					if (plr.currweaponframe == GOBSWORDATTACK + 4 || plr.currweaponframe == ZSHORTATTACK + 4)
						if (plr.currweaponanim == 4 && plr.currweapontics == 10)
							swingdapunch(plr, plr.currweapon);
					break;
				case 3: // morning
					if (plr.currweaponframe == MORNINGSTAR + 5 || plr.currweaponframe == ZSTARATTACK + 7)
						if (plr.currweaponanim == 7 && plr.currweapontics == 12)
							swingdapunch(plr, plr.currweapon);
					if (plr.currweaponframe == MORNINGATTACK2 + 3 || plr.currweaponframe == ZSTARATTACK + 3)
						if (plr.currweaponanim == 3 && plr.currweapontics == 12)
							swingdapunch(plr, plr.currweapon);
					break;
				case 4: // sword
					if (plr.currweaponframe == SWORDATTACK + 7)
						if (plr.currweaponanim == 7 && plr.currweapontics == 8) {
							swingdapunch(plr, plr.currweapon);
							madenoise(plr, 2, plr.x, plr.y, plr.z);
						}
					if (plr.currweaponframe == SWORDATTACK2 + 6)
						if (plr.currweaponanim == 6 && plr.currweapontics == 8) {
							swingdapunch(plr, plr.currweapon);
							madenoise(plr, 2, plr.x, plr.y, plr.z);
						}
					break;
				case 5: // battleaxe
					if (plr.currweaponframe == BIGAXEATTACK + 7 || plr.currweaponframe == ZAXEATTACK + 12)
						if (plr.currweaponanim == 7 && plr.currweapontics == 12)
							swingdapunch(plr, plr.currweapon);
					if (plr.currweaponframe == BIGAXEATTACK2 + 6 || plr.currweaponframe == ZAXEATTACK2 + 6)
						if (plr.currweaponanim == 6 && plr.currweapontics == 12)
							swingdapunch(plr, plr.currweapon);
					break;
				case 6: // bow
					if (plr.currweaponframe == BOWWALK + 4)
						if (plr.currweaponanim == 4 && plr.currweapontics == 6)
							swingdapunch(plr, plr.currweapon);
					if (plr.currweaponframe == ZBOWATTACK + 4)
						if (plr.currweaponanim == 4 && plr.currweapontics == 6)
							swingdapunch(plr, plr.currweapon);
					break;
				case 7: // pike
					if (plr.currweaponframe == PIKEATTACK1 + 4 || plr.currweaponframe == ZPIKEATTACK + 4)
						if (plr.currweaponanim == 8 && plr.currweapontics == 10)
							swingdapunch(plr, plr.currweapon);
					if (plr.currweaponframe == PIKEATTACK2 + 4 || plr.currweaponframe == ZPIKEATTACK2 + 4)
						if (plr.currweaponanim == 4 && plr.currweapontics == 10)
							swingdapunch(plr, plr.currweapon);
					break;
				case 8: // two handed sword
					if (plr.currweaponframe == EXCALATTACK1 + 7 || plr.currweaponframe == ZTWOHANDATTACK + 12)
						if (plr.currweaponanim == 7 && plr.currweapontics == 8)
							swingdapunch(plr, plr.currweapon);
					if (plr.currweaponframe == EXCALATTACK2 + 5 || plr.currweaponframe == ZTWOHANDATTACK2 + 5)
						if (plr.currweaponanim == 5 && plr.currweapontics == 8)
							swingdapunch(plr, plr.currweapon);
					break;
				case 9: // halberd
					if (plr.currweaponframe == HALBERDATTACK1 + 3 || plr.currweaponframe == ZHALBERDATTACK + 4)
						if (plr.currweaponanim == 6 && plr.currweapontics == 12)
							swingdapunch(plr, plr.currweapon);
					if (plr.currweaponframe == HALBERDATTACK2 + 3 || plr.currweaponframe == ZHALBERDATTACK2 + 3)
						if (plr.currweaponanim == 4 && plr.currweapontics == 12)
							swingdapunch(plr, plr.currweapon);
					break;
				}
			}
		}

		if (checkweapondist(hitActor, plr.x, plr.y, plr.z, plr.selectedgun)) {
			madeahit = true;
			auto& hitspr = hitActor->s();

			switch (hitspr.detail) {

			case DEMONTYPE:
			case GONZOTYPE:
			case KATIETYPE:
			case KURTTYPE:
			case NEWGUYTYPE:
			case GRONTYPE:
			case KOBOLDTYPE:
			case DRAGONTYPE:
			case DEVILTYPE:
			case FREDTYPE:
			case SKELETONTYPE:
			case GOBLINTYPE:
			case IMPTYPE:
			case MINOTAURTYPE:
			case SPIDERTYPE:
			case SKULLYTYPE:
			case FATWITCHTYPE:
			case FISHTYPE:
			case RATTYPE:
			case WILLOWTYPE:
			case GUARDIANTYPE:
			case JUDYTYPE:
				if (netgame) {
					// XXX netshootgun(pHitInfo.hitsprite,currweapon);
				}
					
				if(hitspr.statnum == DIE || hitspr.statnum == DEAD) //already dying
					break;

				if (isWh2() && plr.currweapon == 3)
					if (plr.weapon[plr.currweapon] == 3) {
						explosion(hitActor, pHitInfo.hitx, pHitInfo.hity, pHitInfo.hitz, 4096);
					}

				if (plr.invisibletime > 0) {
					if (isWh2()) {
						if ((krand() & 32) > 15)
							plr.invisibletime = -1;
					} else {
						if ((krand() & 1) != 0)
							plr.invisibletime = -1;
					}
				}

				switch (plr.selectedgun) {
				case 0: // fist
					if (isWh2()) {
						k = (krand() % 5) + 1;
						break;
					}
					k = (krand() & 5) + 1;
					break;
				case 1: // dagger
					if (isWh2()) {
						k = (krand() % 5) + 5;
						break;
					}

					if (plr.currweaponattackstyle == 0)
						k = (krand() & 5) + 10;
					else
						k = (krand() & 3) + 5;

					break;
				case 2: // Short sword
					if (isWh2()) {
						k = (krand() % 10) + 5;
						break;
					}

					if (plr.currweaponattackstyle == 0)
						k = (krand() & 10) + 10;
					else
						k = (krand() & 6) + 10;
					break;
				case 3: // morning star
					if (isWh2()) {
						k = (krand() % 15) + 5;
						break;
					}

					if (plr.currweaponattackstyle == 0)
						k = (krand() & 8) + 10;
					else
						k = (krand() & 8) + 15;
					break;
				case 4: // broad sword
					if (isWh2()) {
						k = (krand() % 20) + 5;
						break;
					}

					if (plr.currweaponattackstyle == 0)
						k = (krand() & 5) + 20;
					else
						k = (krand() & 5) + 15;
					break;
				case 5: // battle axe
					if (isWh2()) {
						k = (krand() % 25) + 5;
						switch (hitspr.detail) {
						case GRONTYPE:
						case NEWGUYTYPE:
						case KURTTYPE:
						case GONZOTYPE:
							k += k >> 1;
							break;
						}
						break;
					}

					if (plr.currweaponattackstyle == 0)
						k = (krand() & 5) + 25;
					else
						k = (krand() & 5) + 20;
					break;
				case 6: // bow
					if (isWh2()) {
						k = (krand() % 30) + 5;
						break;
					}

					if (plr.currweaponattackstyle == 0)
						k = (krand() & 15) + 5;
					else
						k = (krand() & 15) + 5;
					break;
				case 7: // pike axe
					if (isWh2()) {
						k = (krand() % 35) + 5;
						break;
					}
					if (plr.currweaponattackstyle == 0)
						k = (krand() & 15) + 10;
					else
						k = (krand() & 15) + 5;
					break;
				case 8: // two handed sword
					if (isWh2()) {
						k = (krand() % 40) + 5;
						break;
					}
					if (plr.currweaponattackstyle == 0)
						k = (krand() & 15) + 45;
					else
						k = (krand() & 15) + 40;
					break;
				case 9: // halberd
					if (isWh2()) {
						k = (krand() % 45) + 5;
						break;
					}

					if (plr.currweaponattackstyle == 0)
						k = (krand() & 15) + 25;
					else
						k = (krand() & 15) + 15;
					break;

				}

				k += plr.lvl;
				if (isWh2() && plr.weapon[plr.currweapon] == 3) {
					k <<= 1;
				}

				if (plr.vampiretime > 0) {
					if (plr.health <= plr.maxhealth)
						addhealth(plr, (krand() % 10) + 1);
				}
				if (plr.helmettime > 0)
					k <<= 1;
				if (plr.strongtime > 0) {
					k += k >> 1;

					switch (plr.currweapon) {
					case 0: // fist
						if (plr.currweaponframe == RFIST + 5)
							if (plr.currweaponanim == 5 && plr.currweapontics == 10)
								swingdacrunch(plr, plr.currweapon);
						break;
					case 1: // knife
						if (plr.currweaponframe == KNIFEATTACK + 6)
							if (plr.currweaponanim == 8 && plr.currweapontics == 8)
								swingdacrunch(plr, plr.currweapon);
						if (plr.currweaponframe == KNIFEATTACK2 + 2)
							if (plr.currweaponanim == 5 || plr.currweaponanim == 9 && plr.currweapontics == 8)
								swingdacrunch(plr, plr.currweapon);
						break;
					case 2: // Short sword
						if (plr.currweaponframe == GOBSWORDATTACK + 4 || plr.currweaponframe == ZSHORTATTACK + 7)
							if (plr.currweaponanim == 4 && plr.currweapontics == 10)
								swingdacrunch(plr, plr.currweapon);
						if (plr.currweaponframe == GOBSWORDATTACK2 + 4 || plr.currweaponframe == ZSHORTATTACK2 + 4)
							if (plr.currweaponanim == 4 && plr.currweapontics == 10)
								swingdacrunch(plr, plr.currweapon);
						break;
					case 3: // morning
						if (plr.currweaponframe == MORNINGSTAR + 5 || plr.currweaponframe == ZSTARATTACK + 7)
							if (plr.currweaponanim == 7 && plr.currweapontics == 12)
								swingdacrunch(plr, plr.currweapon);
						if (plr.currweaponframe == MORNINGATTACK2 + 3 || plr.currweaponframe == ZSTARATTACK2 + 3)
							if (plr.currweaponanim == 3 && plr.currweapontics == 12)
								swingdacrunch(plr, plr.currweapon);
						break;
					case 4: // sword
						if (plr.currweaponframe == SWORDATTACK + 7)
							if (plr.currweaponanim == 7 && plr.currweapontics == 8)
								swingdacrunch(plr, plr.currweapon);
						if (plr.currweaponframe == SWORDATTACK2 + 6)
							if (plr.currweaponanim == 6 && plr.currweapontics == 8)
								swingdacrunch(plr, plr.currweapon);
						break;
					case 5: // battleaxe
						if (plr.currweaponframe == BIGAXEATTACK + 7 || plr.currweaponframe == ZAXEATTACK + 12)
							if (plr.currweaponanim == 7 && plr.currweapontics == 12)
								swingdacrunch(plr, plr.currweapon);
						if (plr.currweaponframe == BIGAXEATTACK2 + 6 || plr.currweaponframe == ZAXEATTACK2 + 6)
							if (plr.currweaponanim == 6 && plr.currweapontics == 12)
								swingdacrunch(plr, plr.currweapon);
						break;
					case 6: // bow
						if (plr.currweaponframe == BOWWALK + 4)
							if (plr.currweaponanim == 4 && plr.currweapontics == 6)
								swingdacrunch(plr, plr.currweapon);
						if (plr.currweaponframe == ZBOWATTACK + 4)
							if (plr.currweaponanim == 4 && plr.currweapontics == 6)
								swingdacrunch(plr, plr.currweapon);
						break;
					case 7: // pike
						if (plr.currweaponframe == PIKEATTACK1 + 4 || plr.currweaponframe == ZPIKEATTACK + 4)
							if (plr.currweaponanim == 8 && plr.currweapontics == 10)
								swingdacrunch(plr, plr.currweapon);
						if (plr.currweaponframe == PIKEATTACK2 + 4 || plr.currweaponframe == ZPIKEATTACK2 + 4)
							if (plr.currweaponanim == 4 && plr.currweapontics == 10)
								swingdacrunch(plr, plr.currweapon);
						break;
					case 8: // two handed sword
						if (plr.currweaponframe == EXCALATTACK1 + 7 || plr.currweaponframe == ZTWOHANDATTACK + 12)
							if (plr.currweaponanim == 7 && plr.currweapontics == 8)
								swingdacrunch(plr, plr.currweapon);
						if (plr.currweaponframe == EXCALATTACK2 + 5 || plr.currweaponframe == ZTWOHANDATTACK2 + 5)
							if (plr.currweaponanim == 5 && plr.currweapontics == 8)
								swingdacrunch(plr, plr.currweapon);
						break;
					case 9: // halberd
						if (plr.currweaponframe == HALBERDATTACK1 + 3 || plr.currweaponframe == ZHALBERDATTACK + 4)
							if (plr.currweaponanim == 6 && plr.currweapontics == 12)
								swingdacrunch(plr, plr.currweapon);
						if (plr.currweaponframe == HALBERDATTACK2 + 3 || plr.currweaponframe == ZHALBERDATTACK2 + 3)
							if (plr.currweaponanim == 4 && plr.currweapontics == 12)
								swingdacrunch(plr, plr.currweapon);
						break;
					}
					hitspr.hitag -= (k << 1);
					if (isWh2() && plr.weapon[plr.currweapon] == 3 && plr.currweapon == 8
							&& hitspr.pal != 6) {
						if (hitspr.hitag <= 0) {
							hitspr.hitag = 1;
						}
						if (krand() % 100 > 50)
							medusa(plr, hitActor);
						break;
					}

					else if (plr.currweapon != 0) {

						// JSA GORE1 you have strong time
						if (krand() % 100 > 50) {
							if (hitspr.picnum == SKELETON
									|| hitspr.picnum == SKELETONATTACK
									|| hitspr.picnum == SKELETONDIE)
								spritesound(S_SKELHIT1 + (krand() % 2), hitActor);
						}

						// HERE
						switch (plr.currweapon) {
						case 0: // fist
							break;
						case 1: // knife
							if (plr.currweaponframe == KNIFEATTACK + 6)
								if (plr.currweaponanim == 8 && plr.currweapontics == 8)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							if (plr.currweaponframe == KNIFEATTACK2 + 2)
								if (plr.currweaponanim == 5 || plr.currweaponanim == 9 && plr.currweapontics == 8)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							break;
						case 2: // Short sword
							if (plr.currweaponframe == GOBSWORDATTACK + 4
									|| plr.currweaponframe == ZSHORTATTACK + 7)
								if (plr.currweaponanim == 4 && plr.currweapontics == 10)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							if (plr.currweaponframe == GOBSWORDATTACK2 + 4
									|| plr.currweaponframe == ZSHORTATTACK + 4)
								if (plr.currweaponanim == 4 && plr.currweapontics == 10)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							break;
						case 3: // morning
							if (plr.currweaponframe == MORNINGSTAR + 5 || plr.currweaponframe == ZSTARATTACK + 7)
								if (plr.currweaponanim == 7 && plr.currweapontics == 12)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							if (plr.currweaponframe == MORNINGATTACK2 + 3
									|| plr.currweaponframe == ZSTARATTACK2 + 3)
								if (plr.currweaponanim == 3 && plr.currweapontics == 12)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							break;
						case 4: // sword
							if (plr.currweaponframe == SWORDATTACK + 7)
								if (plr.currweaponanim == 7 && plr.currweapontics == 8)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							if (plr.currweaponframe == SWORDATTACK2 + 6)
								if (plr.currweaponanim == 6 && plr.currweapontics == 8)
									break;
							chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity, pHitInfo.hitz,
									pHitInfo.hitsect, daang);
						case 5: // battleaxe
							if (plr.currweaponframe == BIGAXEATTACK + 7 || plr.currweaponframe == ZAXEATTACK + 12)
								if (plr.currweaponanim == 7 && plr.currweapontics == 12)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							if (plr.currweaponframe == BIGAXEATTACK2 + 6 || plr.currweaponframe == ZAXEATTACK2 + 6)
								if (plr.currweaponanim == 6 && plr.currweapontics == 12)
									break;
							chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity, pHitInfo.hitz,
									pHitInfo.hitsect, daang);
						case 6: // bow
							if (plr.currweaponframe == BOWWALK + 4)
								if (plr.currweaponanim == 4 && plr.currweapontics == 6)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							if (plr.currweaponframe == ZBOWATTACK + 4)
								if (plr.currweaponanim == 4 && plr.currweapontics == 6)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							break;
						case 7: // pike
							if (plr.currweaponframe == PIKEATTACK1 + 4 || plr.currweaponframe == ZPIKEATTACK + 4)
								if (plr.currweaponanim == 8 && plr.currweapontics == 10)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							if (plr.currweaponframe == PIKEATTACK2 + 4 || plr.currweaponframe == ZPIKEATTACK2 + 4)
								if (plr.currweaponanim == 4 && plr.currweapontics == 10)
									break;
							chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity, pHitInfo.hitz,
									pHitInfo.hitsect, daang);
						case 8: // two handed sword
							if (plr.currweaponframe == EXCALATTACK1 + 7
									|| plr.currweaponframe == ZTWOHANDATTACK + 12)
								if (plr.currweaponanim == 7 && plr.currweapontics == 8)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							if (plr.currweaponframe == EXCALATTACK2 + 5
									|| plr.currweaponframe == ZTWOHANDATTACK2 + 5)
								if (plr.currweaponanim == 5 && plr.currweapontics == 8)
									break;
							chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity, pHitInfo.hitz,
									pHitInfo.hitsect, daang);
						case 9: // halberd
							if (plr.currweaponframe == HALBERDATTACK1 + 3
									|| plr.currweaponframe == ZHALBERDATTACK + 4)
								if (plr.currweaponanim == 6 && plr.currweapontics == 12)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							if (plr.currweaponframe == HALBERDATTACK2 + 3
									|| plr.currweaponframe == ZHALBERDATTACK2 + 3)
								if (plr.currweaponanim == 4 && plr.currweapontics == 12)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							break;
						}
					}

				} else {
					switch (plr.currweapon) {
					case 0: // fist
						if (plr.currweaponframe == RFIST + 5)
							if (plr.currweaponanim == 5 && plr.currweapontics == 10)
								swingdacrunch(plr, plr.currweapon);
						break;
					case 1: // knife
						if (plr.currweaponframe == KNIFEATTACK + 6)
							if (plr.currweaponanim == 8 && plr.currweapontics == 8)
								swingdacrunch(plr, plr.currweapon);
						if (plr.currweaponframe == KNIFEATTACK2 + 2)
							if (plr.currweaponanim == 5 || plr.currweaponanim == 9 && plr.currweapontics == 8)
								swingdacrunch(plr, plr.currweapon);
						break;
					case 2: // SHORT SWORD
						if (plr.currweaponframe == GOBSWORDATTACK + 4 || plr.currweaponframe == ZSHORTATTACK + 7)
							if (plr.currweaponanim == 4 && plr.currweapontics == 10)
								swingdacrunch(plr, plr.currweapon);
						if (plr.currweaponframe == GOBSWORDATTACK2 + 4 || plr.currweaponframe == ZSHORTATTACK2 + 4)
							if (plr.currweaponanim == 4 && plr.currweapontics == 10)
								swingdacrunch(plr, plr.currweapon);
						break;
					case 3: // morning
						if (plr.currweaponframe == MORNINGSTAR + 5 || plr.currweaponframe == ZSTARATTACK + 7)
							if (plr.currweaponanim == 7 && plr.currweapontics == 12)
								swingdacrunch(plr, plr.currweapon);
						if (plr.currweaponframe == MORNINGATTACK2 + 3 || plr.currweaponframe == ZSTARATTACK2 + 3)
							if (plr.currweaponanim == 3 && plr.currweapontics == 12)
								swingdacrunch(plr, plr.currweapon);
						break;
					case 4: // sword
						if (plr.currweaponframe == SWORDATTACK + 7)
							if (plr.currweaponanim == 7 && plr.currweapontics == 8)
								swingdacrunch(plr, plr.currweapon);
						if (plr.currweaponframe == SWORDATTACK2 + 6)
							if (plr.currweaponanim == 6 && plr.currweapontics == 8)
								swingdacrunch(plr, plr.currweapon);
						break;
					case 5: // battleaxe
						if (plr.currweaponframe == BIGAXEATTACK + 7 || plr.currweaponframe == ZAXEATTACK + 12)
							if (plr.currweaponanim == 7 && plr.currweapontics == 12)
								swingdacrunch(plr, plr.currweapon);
						if (plr.currweaponframe == BIGAXEATTACK2 + 6 || plr.currweaponframe == ZAXEATTACK2 + 6)
							if (plr.currweaponanim == 6 && plr.currweapontics == 12)
								swingdacrunch(plr, plr.currweapon);
						break;
					case 6: // bow
						if (plr.currweaponframe == BOWWALK + 4)
							if (plr.currweaponanim == 4 && plr.currweapontics == 6)
								swingdacrunch(plr, plr.currweapon);
						if (plr.currweaponframe == ZBOWATTACK + 4)
							if (plr.currweaponanim == 4 && plr.currweapontics == 6)
								swingdacrunch(plr, plr.currweapon);
						break;

					case 7: // pike
						if (plr.currweaponframe == PIKEATTACK1 + 4 || plr.currweaponframe == ZPIKEATTACK + 4)
							if (plr.currweaponanim == 8 && plr.currweapontics == 10)
								swingdacrunch(plr, plr.currweapon);
						if (plr.currweaponframe == PIKEATTACK2 + 4 || plr.currweaponframe == ZPIKEATTACK2 + 4)
							if (plr.currweaponanim == 4 && plr.currweapontics == 10)
								swingdacrunch(plr, plr.currweapon);
						break;
					case 8: // two handed sword
						if (plr.currweaponframe == EXCALATTACK1 + 7 || plr.currweaponframe == ZTWOHANDATTACK + 12)
							if (plr.currweaponanim == 7 && plr.currweapontics == 8)
								swingdacrunch(plr, plr.currweapon);
						if (plr.currweaponframe == EXCALATTACK2 + 5 || plr.currweaponframe == ZTWOHANDATTACK2 + 5)
							if (plr.currweaponanim == 5 && plr.currweapontics == 8)
								swingdacrunch(plr, plr.currweapon);
						break;
					case 9: // halberd
						if (plr.currweaponframe == HALBERDATTACK1 + 3 || plr.currweaponframe == ZHALBERDATTACK + 4)
							if (plr.currweaponanim == 6 && plr.currweapontics == 12)
								swingdacrunch(plr, plr.currweapon);
						if (plr.currweaponframe == HALBERDATTACK2 + 3 || plr.currweaponframe == ZHALBERDATTACK2 + 3)
							if (plr.currweaponanim == 4 && plr.currweapontics == 12)
								swingdacrunch(plr, plr.currweapon);
						break;
					}
					hitspr.hitag -= k;

					if (isWh2() && plr.weapon[plr.currweapon] == 3 && plr.currweapon == 8
							&& hitspr.pal != 6) {
						if (hitspr.hitag <= 0) {
							hitspr.hitag = 1;
						}
						if (krand() % 100 > 75)
							medusa(plr, hitActor);
						break;
					}

					if (plr.currweapon != 0) {
						// JSA GORE normal
						if (krand() % 100 > 50) {
							if (hitspr.picnum == SKELETON
									|| hitspr.picnum == SKELETONATTACK
									|| hitspr.picnum == SKELETONDIE)
								spritesound(S_SKELHIT1 + (krand() % 2), hitActor);
						}
						// HERE
						switch (plr.currweapon) {
						case 0: // fist
							break;
						case 1: // knife
							if (plr.currweaponframe == KNIFEATTACK + 6)
								if (plr.currweaponanim == 8 && plr.currweapontics == 8)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							if (plr.currweaponframe == KNIFEATTACK2 + 2)
								if (plr.currweaponanim == 5 || plr.currweaponanim == 9 && plr.currweapontics == 8)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							break;
						case 2: // Short sword
							if (plr.currweaponframe == GOBSWORDATTACK + 4
									|| plr.currweaponframe == ZSHORTATTACK + 7)
								if (plr.currweaponanim == 4 && plr.currweapontics == 10)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							if (plr.currweaponframe == GOBSWORDATTACK2 + 4
									|| plr.currweaponframe == ZSHORTATTACK2 + 4)
								if (plr.currweaponanim == 4 && plr.currweapontics == 10)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							break;
						case 3: // morning
							if (plr.currweaponframe == MORNINGSTAR + 5 || plr.currweaponframe == ZSTARATTACK + 7)
								if (plr.currweaponanim == 7 && plr.currweapontics == 12)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							if (plr.currweaponframe == MORNINGATTACK2 + 3
									|| plr.currweaponframe == ZSTARATTACK2 + 3)
								if (plr.currweaponanim == 3 && plr.currweapontics == 12)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							break;
						case 4: // sword
							if (plr.currweaponframe == SWORDATTACK + 7)
								if (plr.currweaponanim == 7 && plr.currweapontics == 8)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							if (plr.currweaponframe == SWORDATTACK2 + 6)
								if (plr.currweaponanim == 6 && plr.currweapontics == 8)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							break;
						case 5: // battleaxe
							if (plr.currweaponframe == BIGAXEATTACK + 7 || plr.currweaponframe == ZAXEATTACK + 12)
								if (plr.currweaponanim == 7 && plr.currweapontics == 12)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							if (plr.currweaponframe == BIGAXEATTACK2 + 6 || plr.currweaponframe == ZAXEATTACK2 + 6)
								if (plr.currweaponanim == 6 && plr.currweapontics == 12)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							break;
						case 6: // bow
							if (plr.currweaponframe == BOWWALK + 4)
								if (plr.currweaponanim == 4 && plr.currweapontics == 6)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							if (plr.currweaponframe == ZBOWATTACK + 4)
								if (plr.currweaponanim == 4 && plr.currweapontics == 6)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							break;
						case 7: // pike
							if (plr.currweaponframe == PIKEATTACK1 + 4 || plr.currweaponframe == ZPIKEATTACK + 4)
								if (plr.currweaponanim == 8 && plr.currweapontics == 10)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							if (plr.currweaponframe == PIKEATTACK2 + 4 || plr.currweaponframe == ZPIKEATTACK2 + 4)
								if (plr.currweaponanim == 4 && plr.currweapontics == 10)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							break;
						case 8: // two handed sword
							if (plr.currweaponframe == EXCALATTACK1 + 7
									|| plr.currweaponframe == ZTWOHANDATTACK + 12)
								if (plr.currweaponanim == 7 && plr.currweapontics == 8)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							if (plr.currweaponframe == EXCALATTACK2 + 5
									|| plr.currweaponframe == ZTWOHANDATTACK2 + 5)
								if (plr.currweaponanim == 5 && plr.currweapontics == 8)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							break;
						case 9: // halberd
							if (plr.currweaponframe == HALBERDATTACK1 + 3
									|| plr.currweaponframe == ZHALBERDATTACK + 4)
								if (plr.currweaponanim == 6 && plr.currweapontics == 12)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							if (plr.currweaponframe == HALBERDATTACK2 + 3
									|| plr.currweaponframe == ZHALBERDATTACK2 + 3)
								if (plr.currweaponanim == 4 && plr.currweapontics == 12)
									chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity,
											pHitInfo.hitz, pHitInfo.hitsect, daang);
							break;
						}
					}
				}

				if (netgame) {
					break;
				}

				if (hitspr.hitag <= 0) {
					if (plr.selectedgun > 1) {
						// JSA GORE on death ?
						// RAF ans:death
						chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity, pHitInfo.hitz,
								pHitInfo.hitsect, daang);
						if (hitspr.picnum == SKELETON
								|| hitspr.picnum == SKELETONATTACK
								|| hitspr.picnum == SKELETONDIE)
							spritesound(S_SKELHIT1 + (krand() % 2), hitActor);
					}
					SetNewStatus(hitActor, DIE);
				}
				hitspr.ang = plr.angle.ang.asbuild() + ((krand() & 32) - 64);
				if (hitspr.hitag > 0)
					SetNewStatus(hitActor, PAIN);
				break;
			} // switch enemytype

			switch (hitspr.detail) {
			case GRONTYPE:
			case KOBOLDTYPE:
			case DRAGONTYPE:
			case DEVILTYPE:
			case FREDTYPE:
			case SKELETONTYPE:
			case GOBLINTYPE:
			case IMPTYPE:
			case MINOTAURTYPE:
			case SKULLYTYPE:
			case SPIDERTYPE:
			case FATWITCHTYPE:
			case JUDYTYPE:
			case NEWGUYTYPE:
			case GONZOTYPE:
			case KURTTYPE:
				if (hitspr.pal == 6) {
					// JSA_NEW
					SND_Sound(S_SOCK1 + (krand() % 4));
					playsound(S_FREEZEDIE, pHitInfo.hitx, pHitInfo.hity);
					for (k = 0; k < 32; k++)
						icecubes(hitActor, pHitInfo.hitx, pHitInfo.hity, pHitInfo.hitz,	pHitInfo.hitsprite);
					addscore(&plr, 100);
					DeleteActor(hitActor);
				}
				break;
			} // switch frozen

			switch (hitspr.picnum) {
			case STAINGLASS1:
			case STAINGLASS2:
			case STAINGLASS3:
			case STAINGLASS4:
			case STAINGLASS5:
			case STAINGLASS6:
			case STAINGLASS7:
			case STAINGLASS8:
			case STAINGLASS9:
				if (!isWh2())
					break;
			case BARREL:
			case VASEA:
			case VASEB:
			case VASEC:

				SetNewStatus(hitActor, BROKENVASE);
				break;
			} // switch
		} // if weapondist

		if (!madeahit) {
			plr.ammo[plr.currweapon]++;
			madeahit = true;
		}
		break;
	case 1: //bow's arrow
		daz2 = -MulScale(plr.horizon.horiz.asq16(), 2000, 16);

		hitscan(plr.x, plr.y, plr.z, plr.sector, // Start position
				bcos(daang), // X vector of 3D ang
				bsin(daang), // Y vector of 3D ang
				daz2, // Z vector of 3D ang
				pHitInfo, CLIPMASK1);

		if (pHitInfo.hitwall > 0 && pHitInfo.hitsprite < 0) { // XXX WH2 sector lotag < 6 || > 8
			if (isWh2()) {
				arrowcnt = (arrowcnt + 1) % ARROWCOUNTLIMIT;
				if (arrowsprite[arrowcnt] != nullptr) {
					DeleteActor(arrowsprite[arrowcnt]);
					arrowsprite[arrowcnt] = nullptr;
				}
			}

			Neartag ntag;
			neartag(pHitInfo.hitx, pHitInfo.hity, pHitInfo.hitz, pHitInfo.hitsect, daang, ntag, 1024, 3);

			if (ntag.tagsector < 0) {
				auto spawnedactor = InsertActor(pHitInfo.hitsect,  0);
				auto& spawned = spawnedactor->s();

				spawned.x = pHitInfo.hitx;
				spawned.y = pHitInfo.hity;
				spawned.z = pHitInfo.hitz + (8 << 8);
				spawned.cstat = 17;// was16
				spawned.picnum = WALLARROW;
				spawned.shade = 0;
				spawned.pal = 0;
				spawned.xrepeat = 16;
				spawned.yrepeat = 48;
				spawned.ang =  (((daang) - 512 + (krand() & 128 - 64)) & 2047);
				spawned.xvel = 0;
				spawned.yvel = 0;
				spawned.zvel = 0;
				spawnedactor->SetPlayerOwner(plr.playerNum());
				spawned.lotag = 32;
				spawned.hitag = 0;
				spawned.backuploc();
				spritesound(S_ARROWHIT, spawnedactor);

				if (isWh2() && plr.weapon[6] == 3 && plr.currweapon == 6) {
					auto spawnedactor = InsertActor(pHitInfo.hitsect, FIRECHUNK);
					auto& spawned = spawnedactor->s();

					spawned.x = pHitInfo.hitx;
					spawned.y = pHitInfo.hity;
					spawned.z = pHitInfo.hitz + (14 << 8);
					spawned.cstat = 0;
					spawned.picnum = ARROWFLAME;
					spawned.shade = 0;
					spawned.pal = 0;
					spawned.xrepeat = 64;
					spawned.yrepeat = 64;
					spawned.ang = 0;
					spawned.xvel = 0;
					spawned.yvel = 0;
					spawned.zvel = 0;
					spawnedactor->SetOwner(nullptr);
					spawned.lotag = 1200;
					spawned.hitag = 0;
					spawned.backuploc();
				}
			}

			if (netgame) {
//					netshootgun(-1,5);
			}
		}
		if (pHitInfo.hitwall > 0 && pHitInfo.hitsprite > 0) {
			auto spawnedactor = InsertActor(pHitInfo.hitsect, FX);
			auto& spawned = spawnedactor->s();

			spawned.x = pHitInfo.hitx;
			spawned.y = pHitInfo.hity;
			spawned.z = pHitInfo.hitz + (8 << 8);
			spawned.cstat = 2;
			spawned.picnum = PLASMA;
			spawned.shade = -32;
			spawned.pal = 0;
			spawned.xrepeat = 32;
			spawned.yrepeat = 32;
			spawned.ang =  daang;
			spawned.xvel = 0;
			spawned.yvel = 0;
			spawned.zvel = 0;
			spawnedactor->SetPlayerOwner(plr.playerNum());
			spawned.lotag = 32;
			spawned.hitag = 0;
			movesprite(spawnedactor, (bcos(spawned.ang) * TICSPERFRAME) << 3,
					(bsin(spawned.ang) * TICSPERFRAME) << 3, 0, 4 << 8, 4 << 8, 0);
			spawned.backuploc();
		}
		if ((hitActor != nullptr) && (hitActor->s().statnum < MAXSTATUS)) {
			auto& hitspr = hitActor->s();
			switch (hitspr.detail) {
			case KURTTYPE:
			case KATIETYPE:
			case NEWGUYTYPE:
			case GONZOTYPE:
			case GRONTYPE:
			case KOBOLDTYPE:
			case DRAGONTYPE:
			case DEMONTYPE:
			case DEVILTYPE:
			case FREDTYPE:
			case SKELETONTYPE:
			case GOBLINTYPE:
			case IMPTYPE:
			case MINOTAURTYPE:
			case SPIDERTYPE:
			case SKULLYTYPE:
			case FATWITCHTYPE:
			case FISHTYPE:
			case RATTYPE:
			case WILLOWTYPE:
			case GUARDIANTYPE:
			case JUDYTYPE:
				if (netgame) {
//						netshootgun(pHitInfo.hitsprite,currweapon);
					break;
				}
				if (isWh2())
					hitspr.hitag -= (krand() & 30) + 15;
				else
					hitspr.hitag -= (krand() & 15) + 15;

				if (hitspr.hitag <= 0) {
					SetNewStatus(hitActor, DIE);
					if (hitspr.picnum == RAT)
						chunksofmeat(plr, hitActor, pHitInfo.hitx, pHitInfo.hity, pHitInfo.hitz,
								pHitInfo.hitsect, daang);
				} else {
					hitspr.ang =  (getangle(plr.x - hitspr.x,
							plr.y - hitspr.y) & 2047);
					SetNewStatus(hitActor, PAIN);
				}
				break;
			}

			switch (hitspr.detail) {
			// SHATTER FROZEN CRITTER
			case GRONTYPE:
			case KOBOLDTYPE:
			case DRAGONTYPE:
			case DEVILTYPE:
			case FREDTYPE:
			case SKELETONTYPE:
			case GOBLINTYPE:
			case IMPTYPE:
			case MINOTAURTYPE:
			case SKULLYTYPE:
			case SPIDERTYPE:
			case FATWITCHTYPE:
			case JUDYTYPE:
			case NEWGUYTYPE:
			case GONZOTYPE:
			case KURTTYPE:
				if (hitspr.pal == 6) {
					// JSA_NEW
					SND_Sound(S_SOCK1 + (krand() % 4));
					playsound(S_FREEZEDIE, pHitInfo.hitx, pHitInfo.hity);
					for (k = 0; k < 32; k++)
						icecubes(hitActor, pHitInfo.hitx, pHitInfo.hity, pHitInfo.hitz,	pHitInfo.hitsprite);
					DeleteActor(hitActor);
				}
			} // switch frozen

			switch (hitspr.picnum) {
			case STAINGLASS1:
			case STAINGLASS2:
			case STAINGLASS3:
			case STAINGLASS4:
			case STAINGLASS5:
			case STAINGLASS6:
			case STAINGLASS7:
			case STAINGLASS8:
			case STAINGLASS9:
				if (!isWh2())
					break;

			case BARREL:
			case VASEA:
			case VASEB:
			case VASEC:
				SetNewStatus(hitActor, BROKENVASE);
				break;
			} // switch
		}
		break;

	case 6: // MEDUSA
	{
		WHSpriteIterator it;
		while (auto itActor = it.Next())
		{
			auto& spk = itActor->s();
			// cansee
			if (itActor != plr.actor()) {
				switch (spk.detail) {
				case FREDTYPE:
				case KOBOLDTYPE:
				case GOBLINTYPE:
				case IMPTYPE:
				case MINOTAURTYPE:
				case SPIDERTYPE:
				case SKELETONTYPE:
				case GRONTYPE:
				case GONZOTYPE:
				case KURTTYPE:
				case NEWGUYTYPE:
					if (cansee(plr.x, plr.y, plr.z, plr.sector, spk.x, spk.y,
							spk.z - (tileHeight(spk.picnum) << 7), spk.sectnum)) {
						// distance check
						if (checkmedusadist(itActor, plr.x, plr.y, plr.z, plr.lvl))
							medusa(plr, itActor);
					}
					break;
				}
			}
		}
		break;
		}
	case 7: // KNOCKSPELL
	{
		daz2 = -MulScale(plr.horizon.horiz.asq16(), 2000, 16);

		Neartag ntag;
		hitscan(plr.x, plr.y, plr.z, plr.sector, // Start position
			bcos(daang), // X vector of 3D ang
			bsin(daang), // Y vector of 3D ang
			daz2, // Z vector of 3D ang
			pHitInfo, CLIPMASK1);

		if (pHitInfo.hitsect < 0 && pHitInfo.hitsprite < 0 || pHitInfo.hitwall >= 0) {

			neartag(pHitInfo.hitx, pHitInfo.hity, pHitInfo.hitz, pHitInfo.hitsect, daang,	ntag, 1024, 3);

			if (ntag.tagsector >= 0) {
				if (sector[ntag.tagsector].lotag >= 60 && sector[ntag.tagsector].lotag <= 69) {
					sector[ntag.tagsector].lotag = 6;
					sector[ntag.tagsector].hitag = 0;
				}
				if (sector[ntag.tagsector].lotag >= 70 && sector[ntag.tagsector].lotag <= 79) {
					sector[ntag.tagsector].lotag = 7;
					sector[ntag.tagsector].hitag = 0;
				}
				operatesector(plr, ntag.tagsector);
			}

		}
		break;
	}
	case 10: // throw a pike axe
		if (plr.currweaponframe == PIKEATTACK1 + 4 || plr.currweaponframe == ZPIKEATTACK + 4) {
			if (plr.currweaponanim == 8 && plr.currweapontics == 10) {
				if (netgame) {
					// netshootgun(-1,15);
				}

				if (isWh2()) {
					throwpikecnt = (throwpikecnt + 1) % THROWPIKELIMIT;
					if (throwpikesprite[throwpikecnt] != nullptr) {
						DeleteActor(throwpikesprite[throwpikecnt]);
						throwpikesprite[throwpikecnt] = nullptr;
					}

					if (plr.weapon[plr.currweapon] == 3) {
						auto spawnedactor = InsertActor(plr.sector, MISSILE);
						auto& spawned = spawnedactor->s();

						throwpikesprite[throwpikecnt] = spawnedactor;
						spawned.x = plr.x;
						spawned.y = plr.y;
						spawned.z = plr.z + (24 << 8);
						spawned.cstat = 21;
						spawned.picnum = THROWPIKE;
						spawned.ang =  (((daang + 2048 + 96) - 512) & 2047);
						spawned.xrepeat = 24;
						spawned.yrepeat = 24;
						spawned.clipdist = 32;
						spawned.extra =  daang;
						spawned.shade = -15;
						spawned.xvel =  ((krand() & 256) - 128);
						spawned.yvel =  ((krand() & 256) - 128);
						if (shootgunzvel != 0) {
							spawned.zvel =  shootgunzvel;
							shootgunzvel = 0;
						} else {
							spawned.zvel = plr.horizon.horiz.asq16() >> 12;
						}
						spawnedactor->SetPlayerOwner(plr.playerNum());
						spawned.lotag = 1024;
						spawned.hitag = 0;
						spawned.pal = 0;
						movesprite(spawnedactor, (bcos(spawned.extra) * TICSPERFRAME) << 3,
								(bsin(spawned.extra) * TICSPERFRAME) << 3, 0, 4 << 8, 4 << 8, 0);
						SetActorPos(spawnedactor, &spawned.pos);
						spawned.backuploc();
					} else {
						auto spawnedactor = InsertActor(plr.sector, MISSILE);
						auto& spawned = spawnedactor->s();

						throwpikesprite[throwpikecnt] = spawnedactor;
						spawned.x = plr.x;
						spawned.y = plr.y;
						spawned.z = plr.z + (24 << 8);
						spawned.cstat = 21;
						spawned.picnum = THROWPIKE;
						spawned.ang = ((plr.angle.ang.asbuild() + 2048 + 96) - 512) & 2047;
						spawned.xrepeat = 24;
						spawned.yrepeat = 24;
						spawned.clipdist = 32;
						spawned.extra = plr.angle.ang.asbuild();
						spawned.shade = -15;
						spawned.xvel =  ((krand() & 256) - 128);
						spawned.yvel =  ((krand() & 256) - 128);
						spawned.zvel = plr.horizon.horiz.asq16() >> 12;
						spawnedactor->SetPlayerOwner(plr.playerNum());
						spawned.lotag = 1024;
						spawned.hitag = 0;
						spawned.pal = 0;
						spawned.backuploc();
					}
				} else {
					auto spawnedactor = InsertActor(plr.sector, MISSILE);
					auto& spawned = spawnedactor->s();

					spawned.x = plr.x;
					spawned.y = plr.y;
					spawned.z = plr.z + (16 << 8);

					// spawned.cstat=17;
					spawned.cstat = 21;

					spawned.picnum = THROWPIKE;
					spawned.ang = BClampAngle((plr.angle.ang.asbuild() + 96) - 512);
					spawned.xrepeat = 24;
					spawned.yrepeat = 24;
					spawned.clipdist = 24;

					spawned.extra = plr.angle.ang.asbuild();
					spawned.shade = -15;
					spawned.xvel =  ((krand() & 256) - 128);
					spawned.yvel =  ((krand() & 256) - 128);
					// spawned.zvel=((krand()&256)-128);
					spawned.zvel = plr.horizon.horiz.asq16() >> 12;
					spawnedactor->SetPlayerOwner(plr.playerNum());
					spawned.lotag = 1024;
					spawned.hitag = 0;
					spawned.pal = 0;
					spawned.backuploc();
				}
			}
		}

		if (plr.currweaponframe == PIKEATTACK2 + 4) {
			if (plr.currweaponanim == 4 && plr.currweapontics == 10) {

				if (isWh2()) {
					throwpikecnt = (throwpikecnt + 1) % THROWPIKELIMIT;
					if (throwpikesprite[throwpikecnt] != nullptr) {
						DeleteActor(throwpikesprite[throwpikecnt]);
						throwpikesprite[throwpikecnt] = nullptr;
					}

					if (plr.weapon[plr.currweapon] == 3) {

						auto spawnedactor = InsertActor(plr.sector, MISSILE);
						auto& spawned = spawnedactor->s();

						throwpikesprite[throwpikecnt] = spawnedactor;
						spawned.x = plr.x;
						spawned.y = plr.y;
						spawned.z = plr.z + (24 << 8);
						spawned.cstat = 21;
						spawned.picnum = THROWPIKE;
						spawned.ang =  daang;

						spawned.xrepeat = 24;
						spawned.yrepeat = 24;
						spawned.clipdist = 32;
						spawned.extra =  daang;

						spawned.shade = -15;
						spawned.xvel =  ((krand() & 256) - 128);
						spawned.yvel =  ((krand() & 256) - 128);
						spawned.zvel = plr.horizon.horiz.asq16() >> 12;
						spawnedactor->SetPlayerOwner(plr.playerNum());
						spawned.lotag = 1024;
						spawned.hitag = 0;
						spawned.pal = 0;
						movesprite(spawnedactor, (bcos(spawned.extra) * TICSPERFRAME) << 3,
								(bsin(spawned.extra) * TICSPERFRAME) << 3, 0, 4 << 8, 4 << 8, 0);
						SetActorPos(spawnedactor, &spawned.pos);
						spawned.backuploc();
					} else {
						auto spawnedactor = InsertActor(plr.sector, MISSILE);
						auto& spawned = spawnedactor->s();

						throwpikesprite[throwpikecnt] = spawnedactor;
						spawned.x = plr.x;
						spawned.y = plr.y;
						spawned.z = plr.z + (24 << 8);
						spawned.cstat = 21;
						spawned.picnum = THROWPIKE;
						spawned.ang = ((plr.angle.ang.asbuild() + 2048 + 96) - 512) & 2047;
						spawned.xrepeat = 24;
						spawned.yrepeat = 24;
						spawned.clipdist = 32;
						spawned.extra = plr.angle.ang.asbuild();
						spawned.shade = -15;
						spawned.xvel =  ((krand() & 256) - 128);
						spawned.yvel =  ((krand() & 256) - 128);
						spawned.zvel = plr.horizon.horiz.asq16() >> 12;
						spawnedactor->SetPlayerOwner(plr.playerNum());
						spawned.lotag = 1024;
						spawned.hitag = 0;
						spawned.pal = 0;
						spawned.backuploc();
					}
				} else {
					auto spawnedactor = InsertActor(plr.sector, MISSILE);
					auto& spawned = spawnedactor->s();

					spawned.x = plr.x;
					spawned.y = plr.y;
					spawned.z = plr.z;

					spawned.cstat = 21;

					spawned.picnum = THROWPIKE;
					spawned.ang = BClampAngle(plr.angle.ang.asbuild() - 512);
					spawned.xrepeat = 24;
					spawned.yrepeat = 24;
					spawned.clipdist = 24;

					spawned.extra = plr.angle.ang.asbuild();
					spawned.shade = -15;
					spawned.xvel =  ((krand() & 256) - 128);
					spawned.yvel =  ((krand() & 256) - 128);
					spawned.zvel =  ((krand() & 256) - 128);
					spawnedactor->SetPlayerOwner(plr.playerNum());
					spawned.lotag = 1024;
					spawned.hitag = 0;
					spawned.pal = 0;
					spawned.backuploc();
				}

			}
		}
		break;
	case 2: // parabolic trajectory
	{
		if (netgame) {
//						netshootgun(-1,12);
		}

		auto spawnedactor = InsertActor(plr.sector, MISSILE);
		auto& spawned = spawnedactor->s();

		spawned.x = plr.x;
		spawned.y = plr.y;
		spawned.z = plr.z + (8 << 8) + ((krand() & 10) << 8);
		spawned.cstat = 0;
		spawned.picnum = PLASMA;
		spawned.shade = -32;
		spawned.pal = 0;
		spawned.xrepeat = 16;
		spawned.yrepeat = 16;
		spawned.ang =  daang;
		spawned.xvel = bcos(daang, -5);
		spawned.yvel = bsin(daang, -5);

		if (shootgunzvel != 0) {
			spawned.zvel =  shootgunzvel;
			shootgunzvel = 0;
		} else {
			spawned.zvel = plr.horizon.horiz.asq16() >> 12;
		}

		spawnedactor->SetPlayerOwner(plr.playerNum());
		spawned.lotag = 256;
		spawned.hitag = 0;
		spawned.clipdist = 48;

		movesprite(spawnedactor, (bcos(spawned.ang) * TICSPERFRAME) << 3,
				(bsin(spawned.ang) * TICSPERFRAME) << 3, 0, 4 << 8, 4 << 8, 0);
		SetActorPos(spawnedactor, &spawned.pos);
		spawned.backuploc();

		break;
	}
	case 3:
	{
		if (netgame) {
//						netshootgun(-1,13);
		}

		auto spawnedactor = InsertActor(plr.sector, MISSILE);
		auto& spawned = spawnedactor->s();

		spawned.x = plr.x;
		spawned.y = plr.y;
		spawned.z = plr.z + (8 << 8);
		spawned.cstat = 0; // Hitscan does not hit other bullets
		spawned.picnum = MONSTERBALL;
		spawned.shade = -32;
		spawned.pal = 0;
		spawned.xrepeat = 64;
		spawned.yrepeat = 64;
		spawned.ang = plr.angle.ang.asbuild();
		spawned.xvel = bcos(daang, -7);
		spawned.yvel = bsin(daang, -7);

		if (shootgunzvel != 0) {
			spawned.zvel =  shootgunzvel;
			shootgunzvel = 0;
		} else {
			spawned.zvel = plr.horizon.horiz.asq16() >> 12;
		}

		spawnedactor->SetPlayerOwner(plr.playerNum());
		spawned.lotag = 256;
		spawned.hitag = 0;
		spawned.clipdist = 64;

		// dax=bcos(spawned.ang, -6);
		// day=bsin(spawned.ang, -6);

		movesprite(spawnedactor, (bcos(spawned.ang) * TICSPERFRAME) << 3,
				(bsin(spawned.ang) * TICSPERFRAME) << 3, 0, 4 << 8, 4 << 8, 0);
		SetActorPos(spawnedactor, &spawned.pos);
		spawned.backuploc();

		break;
	}
	case 4:
	{
		if (netgame) {
//						netshootgun(-1,14);
		}

		WHSpriteIterator it;
		while (auto itActor = it.Next())
		{
			auto& spk = itActor->s();
			switch (spk.detail) {
			case DEMONTYPE:
			case NEWGUYTYPE:
			case KURTTYPE:
			case GONZOTYPE:
			case IMPTYPE:
				if (!isWh2())
					break;

			case SPIDERTYPE:
			case KOBOLDTYPE:
			case DEVILTYPE:
			case GOBLINTYPE:
			case MINOTAURTYPE:
			case SKELETONTYPE:
			case GRONTYPE:
			case DRAGONTYPE:
			case GUARDIANTYPE:
			case FATWITCHTYPE:
			case SKULLYTYPE:
			case JUDYTYPE:
			case WILLOWTYPE:
				if (cansee(plr.x, plr.y, plr.z, plr.sector, spk.x, spk.y,
						spk.z - (tileHeight(spk.picnum) << 7), spk.sectnum))
					if ((isWh2() && itActor->GetPlayerOwner() != plr.playerNum())
							|| checkmedusadist(itActor, plr.x, plr.y, plr.z, 12))
						nukespell(plr, itActor);
				break;
			}
		}
		break;
		}
	}
}

boolean checkweapondist(DWHActor* actor, int x, int y, int z, int guntype) {
	int length = 1024;

	if (guntype != 0) {
		switch (guntype) {
		case 1:
			length = 1024;
			break;
		case 2:
		case 3:
		case 4:
		case 5:
			length = 1536;
			break;
		case 6:
			length = 2048;
			break;
		case 7:
			length = 1024;
			break;
		case 8:
		case 9:
			length = 2048;
			break;
		}
	}
	if (actor == nullptr) return false;
	auto& spr = actor->s();

	if ((abs(x - spr.x) + abs(y - spr.y) < length)
			&& (abs((z >> 8) - ((spr.z >> 8) - (tileHeight(spr.picnum) >> 1))) <= (length >> 3)))
		return true;
	else
		return false;
}

void swingdapunch(PLAYER& plr, int daweapon) {
	switch (daweapon) {
	case 0:// hands
		SND_Sound(S_SOCK4);
		SND_Sound(S_PLRPAIN1 + (krand() % 2));
		addhealth(plr, -1);
		startredflash(10);
		break;
	case 1: // knife
	case 2: // mace
	case 4: // sword
		SND_Sound(S_WALLHIT1);
		break;
	case 3: // arrow
		break;
	case 5:
	case 6:
	case 7:
	case 8:
		SND_Sound(S_WALLHIT1);
		break;
	}
}

void swingdaweapon(PLAYER& plr) {
	float daang = (float)FixedToFloat(plr.angle.ang.asq16());

	if (plr.currweaponframe == BOWWALK + 5 && plr.ammo[6] > 0) {
		plr.currweaponfired = 5;
		plr.currweaponanim = 0;
	}
	if (plr.currweaponframe == BOWWALK + 5 && plr.ammo[6] <= 0) {
		plr.currweaponfired = 0;
		plr.currweaponanim = 0;
		return;
	}

	if (!isWh2()) {
		if (plr.currweaponframe == PIKEATTACK1 + 4
				// || plr.currweaponframe == PIKEATTACK2+4
				&& plr.weapon[7] == 2 && plr.ammo[7] > 0) {
			shootgun(plr, daang, 10);
			spritesound(S_THROWPIKE, plr.actor());
			plr.hasshot = 1;
			return;
		}
	} else {
		if (plr.currweaponframe == BOWWALK + 5 && plr.ammo[6] > 0) {
			plr.currweaponfired = 5;
			plr.currweaponanim = 0;
		} else if (plr.currweaponframe == ZBOWATTACK + 4 && plr.ammo[6] > 0) {
			plr.currweaponfired = 5;
			plr.currweaponanim = 0;
		}

		if (plr.currweaponframe == BOWWALK + 5 && plr.ammo[6] <= 0) {
			plr.currweaponfired = 0;
			plr.currweaponanim = 0;
			return;
		} else if (plr.currweaponframe == ZBOWATTACK + 4 && plr.ammo[6] <= 0) {
			plr.currweaponfired = 0;
			plr.currweaponanim = 0;
			return;
		}

		if (plr.currweaponframe == PIKEATTACK1 + 4 && plr.weapon[7] == 2 && plr.ammo[7] > 0) {
			shootgun(plr, daang, 10);
			spritesound(S_GENTHROW, plr.actor());
			plr.hasshot = 1;
			return;
		} else if (plr.currweaponframe == ZPIKEATTACK + 4 && plr.weapon[7] == 3 && plr.ammo[7] > 0) {
			lockon(plr, 3, 10);
			spritesound(S_GENTHROW, plr.actor());
			plr.hasshot = 1;
			return;
		}
	}

	switch (plr.selectedgun) {
	case 0: // fist & close combat weapons
		shootgun(plr, daang, 0);
		plr.hasshot = 1;
		break;
	case 1: // knife
		shootgun(plr, daang, 0);
		plr.hasshot = 1;
		break;
	case 2: // Shortsword
		shootgun(plr, daang, 0);
		plr.hasshot = 1;
		break;
	case 3: // morningstar
		shootgun(plr, daang, 0);
		if (isWh2() && plr.weapon[plr.selectedgun] == 3) {
			lockon(plr, 1, 3);
		}

		plr.hasshot = 1;
		break;
	case 4: // sword
		shootgun(plr, daang, 0);
		plr.hasshot = 1;
		break;
	case 5: // battleaxe
		if (isWh2() && soundEngine->GetSoundPlayingInfo(SOURCE_Any, nullptr, 0, CHAN_ENCHANTED) != 0)
				SND_Sound(S_ENERGYSWING);

		shootgun(plr, daang, 0);
		plr.hasshot = 1;
		break;
	case 6: // bow
		if (isWh2() && soundEngine->GetSoundPlayingInfo(SOURCE_Any, nullptr, 0, CHAN_ENCHANTED) != 0)
		{
			SND_Sound(S_FIREBALL);
			SND_Sound(S_PLRWEAPON3);
		}
		shootgun(plr, daang, 1);
		plr.hasshot = 1;
		break;
	case 7: // pike
		shootgun(plr, daang, 0);
		plr.hasshot = 1;
		break;
	case 8: // two handed
		shootgun(plr, daang, 0);
		plr.hasshot = 1;
		break;
	case 9: // halberd
		shootgun(plr, daang, 0);
		plr.hasshot = 1;
		break;
	}
}

void swingdacrunch(PLAYER& plr, int daweapon) {

	auto& pspr = plr.actor()->s();
	switch (daweapon) {
	case 0: // fist
		spritesound(S_SOCK1 + (krand() % 4), plr.actor());
		break;
	case 1: // dagger
		if ((krand() % 2) != 0)
			spritesound(S_GORE1 + (krand() % 4), plr.actor());
		break;
	case 2: // Short sword
		spritesound(S_SWORD2 + (krand() % 3), plr.actor());
		break;
	case 3: // morningstar
		spritesound(S_SOCK1 + (krand() % 4), plr.actor());
		break;
	case 4: // broad sword
		spritesound(S_SWORD1 + (krand() % 3), plr.actor());
		break;
	case 5: // battle axe
		if ((krand() % 2) != 0)
			spritesound(S_SOCK1 + (krand() % 4), plr.actor());
		else
			spritesound(S_SWORD1 + (krand() % 3), plr.actor());
		break;
	case 6: // bow

		break;
	case 7: // pike
		if ((krand() % 2) != 0)
			spritesound(S_SOCK1 + (krand() % 4), plr.actor());
		else
			spritesound(S_SWORD1 + (krand() % 3), plr.actor());
		break;
	case 8: // two handed sword
		spritesound(S_SWORD1 + (krand() % 2), plr.actor());
		break;
	case 9: // halberd
		if ((krand() % 2) != 0)
			spritesound(S_SOCK1 + (krand() % 4), plr.actor());
		else
			spritesound(S_SWORD1 + (krand() % 3), plr.actor());
		break;
	}
}

void swingdasound(int daweapon, boolean enchanted) {

	switch (daweapon) {
	case 0: // fist
		SND_Sound(S_PLRWEAPON0);
		break;
	case 1: // knife
		SND_Sound(S_PLRWEAPON1);
		break;
	case 2: // Short sword
		if (isWh2() && enchanted)
			SND_Sound(S_FIRESWING);
		else
			SND_Sound(S_PLRWEAPON4);
		break;
	case 3: // mace
		if (isWh2() && enchanted) {
			SND_Sound(S_FIRESWING);
			SND_Sound(S_FIREBALL);
		} else 
			SND_Sound(S_PLRWEAPON2);
		break;
	case 4: //
		SND_Sound(S_PLRWEAPON4);
		break;
	case 5: // sword
		SND_Sound(S_PLRWEAPON4);
		break;
	case 6: // bow
		SND_Sound(S_PLRWEAPON3);
		break;
	case 7: //
		if (isWh2() && enchanted)
			SND_Sound(S_ENERGYSWING);
		else
			SND_Sound(S_PLRWEAPON4);
		break;
	case 8: //
		SND_Sound(S_PLRWEAPON4);
		break;
	case 9: //
		SND_Sound(S_PLRWEAPON4);
		break;
	}
}

END_WH_NS
